# MetaboDirect
A comprehensive command-line based pipeline for the analysis of direct injection FT-ICR mass spectrometry data.

## Installation

MetaboDirect can be installed directly from [PyPi](https://pypi.org/project/metabodirect/0.1.1/) using:

```
pip install metabodirect
```

Additionally it can be installed from source by cloning its [GitHub repository](https://github.com/Coayala/MetaboDirect)

```
git clone https://github.com/Coayala/MetaboDirect.git
cd MetaboDirect
python setup.py install
```

MetaboDirect requires Python (3.5 and above), R (4 and above) and Cytoscape (3.8 and above) with the following libraries/modules:

### Python

- argparse
- numpy
- pandas
- seaborn
- more-itertools
- py4cytoscape

### R

- tidyverse
- RColorBrewer
- vegan
- ggnewscale
- ggpubr
- vegan
- KEGGREST
- factoextra
- UpSetR
- pmartR (for normalization tests)

### Cytoscape

- FileTransfer

## Usage

Information about the arguments can be obtaining using the option -h/--help

```
metabodirect -h
```
For more information please check the [User Manual](https://coayala.github.io/MetaboDirect/).

# #############################################################
# 
# MetaboDirect
# Data Exploration step
# version 1.0
# by Christian Ayala
#     based on scripts and functions by Nathalia Graf Grachet
# Licensed under the MIT license. See LICENSE.md file.
# 
# #############################################################

suppressPackageStartupMessages({
  library(tidyverse)
  library(RColorBrewer)
  library(ggnewscale)
  library(ggpubr)
  library(rstatix)
  library(pheatmap)
}) 

# Values between two '%' are to be replaced by the correct values during the python script

#### Defining paths and variables ####

setwd('%currentdir%')

my_data.file <- file.path('%outdir%', '5_transformations', 'network_summary_statistics.csv')
my_transf_counts.file <- file.path('%outdir%', '5_transformations', 'Transformations_summary_counts.csv')
my_metadata.file <- file.path('%metadata%')
my_outdir <- file.path('%outdir%', '5_transformations')

#### Import data ####

network_data <-  read_csv(my_data.file, col_types = cols())
transf_counts <- read_csv(my_transf_counts.file, col_types = cols())
metadata <- read_csv(my_metadata.file, col_types = cols())

#### Reformat data files ####

### Change all metadata columns to factors to avoid problems at plotting

for(i in 2:ncol(metadata)){
  metadata[,i] <- factor(as_vector(metadata[,i])) 
}

network_data_longer <- network_data %>%
  pivot_longer(!SampleID, names_to = "Parameters", values_to = "Value") %>% 
  left_join(metadata, by = 'SampleID')

transf_counts_wide <- transf_counts %>% 
  select(SampleID, Transformation, Perc_Counts) %>% 
  column_to_rownames(var = 'SampleID') %>% 
  pivot_wider(names_from = 'Transformation', values_from = 'Perc_Counts') %>% 
  t()


#### Heatmap of percentage of transformations ####

col_annot <- metadata %>% 
  select(SampleID, %group1%, %group2%) %>% 
  column_to_rownames(var = 'SampleID')

row_annot <- transf_counts %>% 
  select(Transformation, Group) %>% 
  distinct() %>% 
  column_to_rownames(var = 'Transformation')

mapcolor <- colorRampPalette(brewer.pal(11, 'RdYlBu'))(100)[100:1]

filename <- filename <- file.path(my_outdir, 'percentage_transformations.pdf')
pdf(filename, height = 10, width = 8)
pheatmap(transf_counts_wide,
         annotation_col = col_annot,
         annotation_row = row_annot,
         color = mapcolor,
         main = 'Transformations (%) per sample')
dev.off()


#### Plot stats summary ####

my_colors <- get_palette('Dark2', length(unique(network_data_longer$%group1%)))
names(my_colors) <- unique(network_data_longer$%group1%) 

group1 <- '%group1%'
group1_s <- syms(group1)

group2 <- '%group2%'
group2_s <- syms(group2)

net_stats_plot <- network_data_longer %>% 
  group_by(%group1%, Parameters) %>% 
  summarise(Mean =  mean(Value), sd = sd(Value), .groups = 'drop') %>% 
  ggplot(aes(x = (!!! group1_s),
             y = Mean,
             fill = (!!! group1_s))) +
  geom_col(position = position_dodge(.9), color = 'black') +
  geom_errorbar(aes(ymin = Mean - sd,
                    ymax = Mean + sd),
                position = position_dodge(.9),
                width = .2) +
  scale_fill_manual(values = my_colors) +
  theme_bw() +
  labs(title = 'Network statistics summary',
       x = group1,
       fill = group1) +
  theme(plot.title = element_text(face = 'bold', hjust = 0.5),
        axis.title.y = element_blank()) +
  facet_wrap(~Parameters, scales = "free_y", ncol = 3) 

filename <- file.path(my_outdir, 'network_statistics_summary.png')
ggsave(filename, net_stats_plot, dpi = 300)

network_parameters <- unique(network_data_longer$Parameters)

for(param in network_parameters){
  param_df <- network_data_longer %>% 
    filter(Parameters == param)
  
  kw <- param_df %>% 
    group_by(%group2%) %>% 
    kruskal_test(Value ~ %group1%)
  filename <- file.path(my_outdir, paste0(param, '_kruskal_test_by_', group1, '.csv'))
  write_csv(kw, filename)
  
  gh <- param_df %>% 
    group_by(%group2%) %>% 
    games_howell_test(Value ~ %group1%) %>% 
    add_y_position()
  
  param_plot <- ggplot(param_df,
                       aes(x = (!!! group1_s),
                           y = Value,
                           fill = (!!! group1_s))) +
    geom_boxplot() +
    scale_fill_manual(values = my_colors) +
    stat_pvalue_manual(gh,
                       label = 'p.adj.signif', inherit.aes = FALSE,
                       hide.ns = TRUE) +
    theme_bw() +
    labs(title = param,
         x = group1,
         fill = group1) +
    theme(plot.title = element_text(face = 'bold', hjust = 0.5),
          axis.title.y = element_blank()) +
    facet_grid(cols = vars(%group2%))
  
  filename <- file.path(my_outdir, paste0(param, '_by_', group1, '.png'))
  ggsave(filename, param_plot, dpi = 300)
}

# ***************************************************************
# 
# MetaboDirect
# Data Exploration step
# version 1.0
# by Christian Ayala
#     based on scripts and functions by Nathalia Graf Grachet
# Licensed under the MIT license. See LICENSE.md file.
# 
# ***************************************************************

library(tidyverse)
library(RColorBrewer)
library(ggpubr)
library(vegan)
library(SYNCSA)

# Values between two '%' are to be replaced by the correct values during the python script

# Defining variables ----

current_dir <- '%currentdir%'
output_dir <- '%outdir%'
group1 <- '%group1%'
group2 <- '%group2%'

setwd(current_dir)

# Loading custom functions ----
source(file.path(output_dir, 'custom_functions.R'))

my_data.file <- file.path(output_dir, '1_preprocessing_output', 'Report_processed_noNorm.csv')
my_metadata.file <- file.path('%metadata%')
my_outdir <- file.path(output_dir, '4_chemodiversity')

#### Import data ----

df <-  read_csv(my_data.file)
metadata <- read_csv(my_metadata.file)

# Reformat data files ----

## Change all metadata columns to factors to avoid problems at plotting

metadata <- metadata %>% 
  mutate(across(!SampleID, as.factor))

## Intensity matrix

intensity_matrix <- df %>%
  select(Mass, all_of(metadata$SampleID)) %>%
  column_to_rownames(var = 'Mass') %>% 
  t()

## Sum normalize intensities

norm_intensity_matrix <- decostand(intensity_matrix, method = 'total')

# Set samples color names ----

my_colors <- set_names(get_palette('Dark2', length(unique(metadata[[group1]]))),
                       nm = unique(metadata[[group1]]))

# Abundance-based diversity ----

## Richness

richness <- calculate_richness(norm_intensity_matrix)

richness_plot <- ggplot(richness,
                        aes(x = Sites,
                            y = Richness,
                            group = Sites)) +
  geom_boxplot(fill = 'yellow') +
  geom_hline(yintercept = max(richness$Richness) * 0.85, color = 'red') +
  theme_bw() +
  labs(title = 'Richness plot') +
  custom_theme()

filename <- file.path(my_outdir, '1.1_Diversity_plot_richness.png')
ggsave(filename, richness_plot, dpi = 300, width = 8, height = 8)

## Rank abundance ----

rank_sums <- calculate_rank_abundance(norm_intensity_matrix)

rank_plot <- ggplot(rank_sums,
                    aes(x = position,
                        y = intensity_sums,
                        color = presence_perc)) +
  geom_point() +
  scale_color_distiller(palette = 'RdYlBu', limits = c(0, 100)) +
  theme_bw() +
  labs(title = 'Rank abundance plot',
       y = 'Total relative abundance',
       x = 'Molecular rank',
       color = 'Presence') +
  custom_theme()

rank_plot

filename <- file.path(my_outdir, '1.2_Diversity_plot_rank_abundance.png')
ggsave(filename, rank_plot, dpi = 300, width = 8, height = 8)

## Diversity Index ----

diversity_table <- calculate_diversity_index(intensity_matrix, norm_intensity_matrix)

diversity_plot <- plot_diversity_index(diversity_table, group_by = group1,
                                       title = 'Abundance-based Diversity')

filename <- file.path(my_outdir, '2.2_abundance_diversity_plot.png')
ggsave(filename, diversity_plot, dpi = 300, width = 8, height = 8)

# Functional diversity ----

functional_diversity <- calculate_functional_div_index(df, norm_intensity_matrix)

functional_div_plot <- plot_diversity_index(functional_diversity, group_by = group1,
                                            title = 'Functional-based Diversity') +
  labs(subtitle = "Rao's quadratic entropy")

filename <- file.path(my_outdir, '3.2_functional_diversity_plot.png')
ggsave(filename, functional_div_plot, dpi = 300, width = 8, height = 8)

# Calculate SPANS Score for a Number of Normalization Methods
# Based on the spans functions from the pmartR package (https://github.com/pmartR/pmartR)
# 

modified_spans_procedure <- function(omicsData, norm_fn = c('max', 'mean', 'median', 'minmax', 'sum', 'zscore'), 
                                     subset_fn = c("all", "los", "ppp"), params = NULL, group = NULL, n_iter = 1000, 
                                     sig_thresh = 0.0001, nonsig_thresh = 0.5, 
                                     min_nonsig = 20, min_sig = 20, ...){
  .spans_procedure(omicsData, norm_fn = norm_fn, subset_fn = subset_fn, params = params, group = group, 
                   n_iter = n_iter, sig_thresh = sig_thresh, nonsig_thresh = nonsig_thresh, min_nonsig = min_nonsig, 
                   min_sig = min_sig, ...)
}

.spans_procedure <- function(omicsData, norm_fn = c('max', 'mean', 'median', 'minmax', 'sum', 'zscore'), 
                             subset_fn = c("all", "los", "ppp", "rip", "ppp_rip"), 
                             params = NULL, group = NULL, n_iter = 1000, sig_thresh = 0.0001, nonsig_thresh = 0.5, 
                             min_nonsig = 20, min_sig = 20, max_nonsig = NULL, max_sig = NULL, location_thresh = 0.05, 
                             scale_thresh = 0.05, verbose = TRUE, parallel = TRUE){ 
  
  edata_cname = get_edata_cname(omicsData)
  fdata_cname = get_fdata_cname(omicsData)
  nsamps = attributes(omicsData)$data_info$num_samps
  
  # error checks
  if(!inherits(omicsData, c("pepData", "proData"))) stop("omicsData must be of class 'pepData', or 'proData'")
  
  # params defaults if none specified
  if(is.null(params)){
    params <- list("los" = list(0.05,0.1,0.2,0.3), 
                   "ppp" = list(0.1,0.25,0.50,0.75))
    
    for(name in names(params)){
      if(!(name %in% subset_fn)){
        params[[name]] <- NULL
      }
    }
  }
  
  # simple function to check if an element of params contains all values between 0 and 1
  checkvals <- function(list){
    sapply(list, function(x){
      isTRUE(all(x >= 0) & all(x<=1))
    })
  }
  
  if(!isTRUE(all(names(params) %in% c("los", "ppp")))) stop("params must be a named list with names of the normalization functions to be tested, one or more of: 'los', 'ppp'")
  
  # subset function parameter value checks
  if("los" %in% subset_fn){
    if(is.null(params$los)) stop("params must contain a list element named 'los'")
    if(!all(checkvals(params$los))) stop("each element of 'los' in params must be a numeric value between 0 and 1")
  }
  if("ppp" %in% subset_fn){
    if(is.null(params$ppp)) stop("params must contain a list element named 'ppp'")
    if(!all(checkvals(params$ppp))) stop("each element of 'ppp' in params must be a numeric value between 0 and 1")
  }

  # assign group variable or internally call group_designation() if user specified a grouping column in f_data
  omicsData <- group_designation(omicsData, main_effects = group)
  group_df = attr(omicsData, "group_DF")
  reorder = match(colnames(omicsData$e_data)[-which(colnames(omicsData$e_data) == edata_cname)], as.character(group_df[,fdata_cname]))
  group = group_df[reorder,]$Group
  
  # misc input checks
  if(!inherits(attr(omicsData, "group_DF"), "data.frame")) stop("the omicsData object must have a grouping structure, usually set by calling group_designation() on the object")
  if(any(c(min_nonsig, min_sig) < 1) | any(c(min_nonsig, min_sig) > nrow(omicsData$e_data))) stop("min_nonsig and min_sig must be an integer value no greater than the number of observed biomolecules")
  if(!is.null(max_sig)){
    if(!is.numeric(max_sig) | max_sig <= min_sig) stop('max_sig must be an integer value greater than min_sig')
  }
  if(!is.null(max_nonsig)){
    if(!is.numeric(max_nonsig) | max_nonsig <= min_nonsig) stop('max_nonsig must be an integer value greater than min_nonsig')
  }
  if(!all(subset_fn %in% c("all", "los", "ppp", "complete", "rip", "ppp_rip"))) stop("subset_fn must be a character vector containing more than one of the elements 'all', 'los', 'ppp', 'complete', 'rip', 'ppp_rip'")
  if(is.null(attr(omicsData, "group_DF"))) stop("omicsData object must have a grouping structure set by calling group_designation()")
  
  ### end main error checking ###
  
  # get indices of significant and nonsignificant p-values
  kw_pvals <- kw_rcpp(omicsData$e_data %>% dplyr::select(-edata_cname) %>% as.matrix(), as.character(group))
  
  # initial storage of both vectors
  sig_inds <- (kw_pvals <= sig_thresh & !is.na(kw_pvals))
  nonsig_inds <- (kw_pvals >= nonsig_thresh & !is.na(kw_pvals))
  
  ## these two while loops change the p-value threshold until at least min_sig and min_nonsig indices are selected
  
  # low to high p-values from KW test
  ordered_vals <- kw_pvals[!is.na(kw_pvals)] %>% unique() %>% sort()
  iter <- 1
  # while we dont have enough indices, add the indices corresponding to the 1:iter lowest p-values
  while(sum(sig_inds) < min_sig){
    sig_inds <- kw_pvals %in% ordered_vals[1:iter]
    iter <- iter + 1
  }
  
  # same thing but for high p-values
  ordered_vals <- kw_pvals[!is.na(kw_pvals)] %>% unique() %>% sort(decreasing = TRUE)
  iter <- 1
  while(sum(nonsig_inds) < min_nonsig){
    nonsig_inds <- kw_pvals %in% ordered_vals[1:iter]
    iter <- iter + 1
  }
  
  # if user set a maximum for the number of significant and nonsignificant molecules and we are over the maximum
  # randomly sample max_sig indices from the indices of significant molecules ...
  if(!is.null(max_sig)){
    if(sum(sig_inds) > max_sig){
      make_false <- sample(which(sig_inds), sum(sig_inds) - max_sig)
      sig_inds[make_false] <- FALSE
    }
  }
  # ... and max_nonsig indices from the indices of non-significant molecules.
  if(!is.null(max_nonsig)){
    if(sum(nonsig_inds) > max_nonsig){
      make_false <- sample(which(nonsig_inds), sum(nonsig_inds) - max_nonsig)
      nonsig_inds[make_false] <- FALSE
    }
  }
  
  # get a vector of n_iter sample sizes for randomly selecting peptides to determine normalization factors
  scaling_factor <- sum(!is.na(omicsData$e_data %>% dplyr::select(-edata_cname)))/100
  select_n <- ceiling(runif(n_iter, nsamps/scaling_factor, 100)*scaling_factor) - nsamps
  
  ### produce a list with all combinations of subset functions, normalization functions, and parameters ###
  all_calls <- list()
  
  # for each normalization/subset method combination...
  for(nf in norm_fn){
    for(sf in subset_fn){
      #...if it is a normalization function that doesn't have parameters specified, just append a list of the normalization and subset function names...
      if(is.null(params[[sf]])){
        all_calls[[length(all_calls)+1]] <- list(norm_fn = nf, subset_fn = sf)
      }
      #...otherwise append the same list with a parameters variable as well
      else{
        for(par in params[[sf]]){
          if(sf == "los") temp_par <- list("los" = par)
          if(sf == "ppp") temp_par <- list("ppp" = par)
          all_calls[[length(all_calls)+1]] <- list(norm_fn = nf, subset_fn = sf, params = temp_par)
        }
      }
    }
  }
  
  if(length(all_calls) < 2) stop("Your input parameters did not result in more than 1 normalization method.")
  
  n_methods <- length(all_calls)
  
  ### STEP 0:  create random distribution ####
  
  # set up parallel backend
  if(parallel){
    cores<- parallel::detectCores()
    cl<- parallel::makeCluster(cores)
    on.exit(parallel::stopCluster(cl))
    doParallel::registerDoParallel(cl)
  } else foreach::registerDoSEQ()
  
  # get a median significant and non-significant p-value for n_iter iterations
  background_distribution <- foreach::foreach(i = 1:n_iter, .packages = "pmartR",
                                              .export = c('spans_make_distribution', 'data_normalization', 'kw_rcpp')) %dopar% {
    # function defined at bottom of this script
    spans_make_distribution(omicsData, norm_fn, sig_inds, nonsig_inds, select_n[i])
  }

  # # make empirical cdfs based on vectors of n_iter median p-values
  sig_cdf <- sapply(background_distribution, function(el){el[[1]]}) %>% ecdf()
  nonsig_cdf <- sapply(background_distribution, function(el){el[[2]]}) %>% ecdf()
  
  if(verbose) print("Finished creating background distribution, moving to method candidate selection")
  
  #### STEP 1:  
  # determine which methods (subset function + normalization function + parameters combination) will be assessed in step 2.
  # returned list contains information on the method applied and a T/F value for whether it passed to step 2.

  which_spans <- foreach::foreach(i = 1:length(all_calls), .packages = c("pmartR", 'tidyverse'), 
                                  .export = c('data_normalization', 'kw_rcpp')) %dopar% {
    
    el <- all_calls[[i]]
    norm_object <- data_normalization(omicsData$e_data, norm_method = el$norm_fn, norm_subset = el$subset_fn, subset_parameter = el$params)
    
    p_scale <- kw_rcpp(t(as.matrix(norm_object$scale_param)), group = as.character(group))
    
    if(!is.null(norm_object$location_param)){
      p_location <- kw_rcpp(t(as.matrix(norm_object$location_param)), group = as.character(group))
      if(any(c(p_location, p_scale) < c(location_thresh, scale_thresh))){
        res <- list(passfail = FALSE, step1_pvals = c(p_location, p_scale))
      } else {
        res <- list(passfail = TRUE, step1_pvals = c(p_location, p_scale))
      }
    } else if(p_scale < scale_thresh) {
      res <- list(passfail = FALSE, step1_pvals = c(NA, p_scale))
    } else {
      res <- list(passfail = TRUE, step1_pvals = c(NA, p_scale))
    }
    
    res <- c(el, res)
    
    return(res)
    
  }
  
  if(verbose) print("Finished method candidate selection, proceeding to score selected methods.")

  # STEP 2: Score each method that passed step 1 by normalizing the full data and getting median Kruskal-Wallis p-values for significant and nonsignificant peptides

  scores <- foreach::foreach(el = which_spans, .packages = "pmartR", .export = c('data_normalization', 'kw_rcpp')) %dopar% {
    if(el$passfail){
      norm_data <- data_normalization(omicsData$e_data, norm_method = el$norm_fn, norm_subset = el$subset_fn, subset_parameter = el$params)
      abundance_matrix <- norm_data$norm_matrix

      sig_score <- -log10(median(kw_rcpp(abundance_matrix[sig_inds,], group = as.character(group)), na.rm = TRUE))
      non_sig_score <- log10(median(kw_rcpp(abundance_matrix[nonsig_inds,], group = as.character(group)), na.rm = TRUE))

      score <- (sig_cdf(sig_score) + nonsig_cdf(non_sig_score))/2

      return(list(score, sig_cdf(sig_score), nonsig_cdf(non_sig_score)))
    }
    else return(list(NA, NA, NA))
  }

  if(verbose) print("Finished scoring selected methods")

  # create dataframe with selected methods
  spansres_obj <- data.frame("subset_method" = character(n_methods), "normalization_method" = character(n_methods), "SPANS_score" = numeric(n_methods),
                             "parameters" = character(n_methods), "passed_selection" = logical(n_methods),
                             stringsAsFactors = FALSE, check.names = FALSE)

  extra_info <- data.frame("subset_method" = character(n_methods), "normalization_method" = character(n_methods), "parameters" = character(n_methods),
                           "location_p_value" = numeric(n_methods), "scale_p_value" = numeric(n_methods),
                           "F_log_HSmPV" = numeric(n_methods), "F_log_NSmPV" = numeric(n_methods),
                           "SPANS_score" = numeric(n_methods), stringsAsFactors = FALSE, check.names = FALSE)

  # populate the dataframe from which_spans
  for(i in 1:n_methods){
    ss <- which_spans[[i]]$subset_fn
    norm <- which_spans[[i]]$norm_fn
    score <- scores[[i]][[1]]
    params <- which_spans[[i]]$params %>% unlist() %>% as.character() %>% paste(collapse = ";")
    p_loc <- which_spans[[i]]$step1_pvals[1]
    p_scale <- which_spans[[i]]$step1_pvals[2]
    F_HSmPV <- scores[[i]][[2]]
    F_NSmPV <- scores[[i]][[3]]
    pass_fail <- which_spans[[i]]$passfail

    # store into row of df
    spansres_obj[i,] <- list(ss, norm, score, params, pass_fail)
    extra_info[i, ] <- list(ss, norm, params, p_loc, p_scale, F_HSmPV, F_NSmPV, score)
  }

  spansres_obj <- dplyr::arrange(spansres_obj, dplyr::desc(SPANS_score))
  extra_info <- dplyr::arrange(extra_info, dplyr::desc(SPANS_score)) %>% dplyr::select(-SPANS_score)

  attr(spansres_obj, "method_selection_pvals") <- extra_info
  attr(spansres_obj, "group_vector") = group
  attr(spansres_obj, "significant_thresh") = sig_thresh
  attr(spansres_obj, "nonsignificant_thresh") = nonsig_thresh
  attr(spansres_obj, "n_not_significant") = sum(nonsig_inds)
  attr(spansres_obj, "n_significant") = sum(sig_inds)
  attr(spansres_obj, "location_threshold") = location_thresh
  attr(spansres_obj, "scale_thresh") = scale_thresh
  class(spansres_obj) <- c("SPANSRes", "data.frame")

  return(spansres_obj)
  
}

#' Creates the list of median p-values used to make the background distribution used to compute the SPANS score in step 2.
#' 
#' @param omicsData an object of the class 'pepData', 'proData', 'lipidData', or 'metabData' usually created by \code{\link{as.pepData}}, \code{\link{as.proData}}, \code{\link{as.lipidData}}, or  \code{\link{as.metabData}}, respectively.
#' @param norm_fn a character vector of normalization methods to choose from.  Current options are 'mean', 'median', 'zscore', and 'mad'.
#' @param sig_inds significant peptide indices (row indices) based on a Kruskal-Wallis test on the un-normalized data
#' @param nonsig_inds non-significant peptide indices (row indices) based on a Kruskal-Wallis test on the un-normalized data
#' @param select_n number of peptide by sample indices in the data to randomly select to determine normalization parameters
#' 
#' @return a list with 2 elements. The median of highly significant p-values, and the median of nonsignificant p-values.
#'  These are obtained from a SINGLE Kruskal-Wallis test on data normalized by scale/location factors determined from a randomly selected subset of peptides and normalization method
spans_make_distribution <- function(omicsData, norm_fn, sig_inds, nonsig_inds, select_n){
  edata_cname = get_edata_cname(omicsData)
  group_df = attr(omicsData, "group_DF")
  
  # put the samples in the group vector in the same order as in the columns of e_data
  reorder = match(colnames(omicsData$e_data)[-which(colnames(omicsData$e_data) == edata_cname)], as.character(group_df[,get_fdata_cname(omicsData)]))
  group_vector = as.character(group_df[reorder,]$Group)
  nsamps = attributes(omicsData)$data_info$num_samps
  
  # need a matrix to pass to kw_rcpp
  abundance_matrix <- omicsData$e_data %>% dplyr::select(-edata_cname) %>% as.matrix()
  
  # indices vector that will be used for subsetting
  inds <- NULL
  
  # for each sample, randomly select an index to include for that sample, this ensures each sample gets at least 1 observation
  # remember matrices are stored as vectors, we select elements using a single number
  for(j in 1:nsamps){
    forced_ind <- sample(which(!is.na(abundance_matrix[,j])), 1)*j
    inds <- c(inds, forced_ind)
  }
  
  # randomly assign the rest of the indices
  inds <- c(inds, sample(setdiff(which(!is.na(abundance_matrix)), inds), select_n))
  
  # randomly select a normalization method
  rand_norm <- sample(norm_fn ,1)
  
  # Normalize random distributions using own normalization methods
  
  abundance_matrix <- data_normalization(cbind(omicsData$e_data %>% dplyr::select(edata_cname), replace(abundance_matrix, -inds, NA)), rand_norm)
  # # get normalization parameters from ubsetted matrix.  
  # # normalize_global_matrix is not intended to be used outside this function, it returns the location and (if applicable) scale parameters for normalization.
  # norm_params <- normalize_global_matrix(cbind(omicsData$e_data %>% dplyr::select(edata_cname), replace(abundance_matrix, -inds, NA)),
  #                                        rand_norm, apply_norm = FALSE)
  # 
  # # apply the normalization
  # lapply(1:ncol(abundance_matrix), function(i){
  #   abundance_matrix[,i] <<- abundance_matrix[,i] - norm_params$location[i]
  #   if(!is.null(norm_params$scale)) abundance_matrix[,i] <<- abundance_matrix[,i]/norm_params$scale[i]
  # })
  
  # run Kruskal-Wallis on the normalized dataset
  hs_mpv <- kw_rcpp(abundance_matrix$norm_matrix[sig_inds,], group_vector)
  ns_mpv <- kw_rcpp(abundance_matrix$norm_matrix[nonsig_inds,], group_vector)
  
  # NA values are from peptides with no observations in 1 group
  hs_mpv <- hs_mpv[!is.na(hs_mpv)]
  ns_mpv <- ns_mpv[!is.na(ns_mpv)]
  
  # log transformed median p-values
  hs_mpv <- -log10(median(hs_mpv))
  ns_mpv <- log10(median(ns_mpv))
  
  return(list(hs_mpv, ns_mpv))
}

#' Gets the parameters for the highest ranked methods from spans.
#' 
#' @param SPANSRes_obj an object of the class SPANSRes obtained by calling \code{spans_procedure()}
#' 
#' @return A list of lists, where there are multiple sublists only if there were ties for the top SPANS score.  Each sublist contains named elements for the subset and normalization methods, and the parameters used for the subset method. \cr
#' 
#' @examples 
#' 
#' library(pmartR)
#' library(pmartRdata)
#' 
#' data(pep_object)
#' 
#' # data must be log transformed and grouped
#' myobject <- edata_transform(pep_object, data_scale = "log2")
#' myobject <- group_designation(myobject, main_effects = "Condition")
#' 
#' spans_result <- spans_procedure(myobject)
#' 
#' # a list of the parameters for any normalization procedure with the best SPANS score
#' best_params <- get_spans_params(spans_result)
#' 
#' # extract the arguments from the first list element
#' subset_fn = best_params[[1]]$subset_fn
#' norm_fn = best_params[[1]]$norm_fn
#' params = best_params[[1]]$params
#' 
#' # pass arguments to normalize global
#' norm_object <- normalize_global(omicsData = myobject, subset_fn = subset_fn, norm_fn = norm_fn, params = params)
#' 
#' @export 
get_spans_params <- function(SPANSRes_obj, sort_by_nmols = FALSE){
  
  if(all(is.na(SPANSRes_obj$SPANS_score))) stop("No methods were selected for scoring, there is no 'best' set of parameters to return.")
  
  # get rows that are tied for top score
  best_df <- SPANSRes_obj %>% 
    dplyr::top_n(1, wt = SPANS_score)
  
  if(sort_by_nmols){
    best_df <- best_df %>%
      dplyr::top_n(1, mols_used_in_norm) 
  }
  
  ## populate a list with the subset method, normalization method, and subset parameters.
  params <- vector("list", nrow(best_df))
  
  for(i in 1:nrow(best_df)){
    params[[i]][["subset_fn"]] = best_df[i, "subset_method"]
    params[[i]][["norm_fn"]] = best_df[i, "normalization_method"]
    
    pars_from_df = as.numeric(strsplit(best_df[i,"parameters"], ";")[[1]])
    
    if(params[[i]][["subset_fn"]] == "ppp_rip"){
      params[[i]][["params"]] = list(ppp_rip = list(ppp = pars_from_df[1], rip = pars_from_df[2]))
    }
    else if(params[[i]][["subset_fn"]] == "all"){
      params[[i]][["params"]] = list(NULL)
    }
    else if(params[[i]][["subset_fn"]] %in% c("los", "rip", "ppp")){
      sublist = list()
      sublist[[params[[i]]["subset_fn"]]] <- pars_from_df
      params[[i]][["params"]] <- sublist
    }
  }
  
  return(params)
}

kw_rcpp <- function(mtr, group) {
  .Call('_pmartR_kw_rcpp', PACKAGE = 'pmartR', mtr, group)
}

data_normalization <- function(edata, norm_method, norm_subset = 'all', subset_parameter = NULL){
  
  if(is.null(subset_parameter)){
    subset_parameter <- 1
  } else {
    subset_parameter <- as.numeric(subset_parameter)
  }
  id_list <- edata[, 1]
  
  # Data subsetting
  
  if(norm_subset == 'ppp'){
    min_observations <- as.integer(subset_parameter * ncol(edata))
    observations <- rowSums(!is.na(edata[-1]))
    observations <- observations > min_observations
    selected_peaks = edata$Mass[observations]
  } else if (norm_subset == 'los'){
    ntop_peaks <- as.integer(subset_parameter * nrow(edata))
    selected_peaks <- list()
    for(sample in 1:ncol(edata)){
      peaks <- edata[, sample]
      names(peaks) <- id_list
      ord_peaks <- sort(abs(peaks), decreasing = TRUE)
      selected_peaks <- names(ord_peaks[1:ntop_peaks])
    }
    selected_peaks <- unique(selected_peaks)
  } else {
    selected_peaks <- id_list
  }
  
  subset_edata <- edata[edata$Mass %in% selected_peaks,]
  subset_edata <- subset_edata[-1]
  edata <- edata[-1]
  
  # Calculating normalization parameters and scales
  sample_mean <- apply(subset_edata, 2, mean, na.rm = TRUE)
  sample_min <- apply(subset_edata, 2, min, na.rm = TRUE)
  sample_max <- apply(subset_edata, 2, max, na.rm = TRUE)
  sample_median <- apply(subset_edata, 2, median, na.rm = TRUE)
  sample_std <- apply(subset_edata, 2, sd, na.rm = TRUE)
  sample_sum <- apply(subset_edata, 2, sum, na.rm = TRUE)
  
  edata <- t(edata)
  
  norm_data = list(location_param = NA, scale_param = NA, norm_matrix = NA)
  
  if(norm_method == 'mean'){
    norm_data$location_param <- sample_mean
    norm_data$scale_param <- (sample_max - sample_min)
  } else if(norm_method == 'median'){
    norm_data$location_param <- sample_median
    norm_data$scale_param <- (sample_max - sample_min)
  } else if(norm_method == 'zscore'){
    norm_data$location_param <- sample_mean
    norm_data$scale_param <- sample_std
  } else if(norm_method == 'sum'){
    norm_data$location_param <- NULL
    norm_data$scale_param <- sample_sum
  } else if(norm_method == 'max'){
    norm_data$location_param <- NULL
    norm_data$scale_param <- sample_max
  } else if(norm_method == 'minmax'){
    norm_data$location_param <- sample_min
    norm_data$scale_param <- (sample_max - sample_min)
  }
  
  if(!is.null(norm_data$location_param)){
    norm_data$norm_matrix <- t((edata - norm_data$location_param) / norm_data$scale_param)
  } else{
    norm_data$norm_matrix <- t(edata / norm_data$scale_param)
  }
  
  
  return(norm_data)
}

# ***************************************************************
# 
# MetaboDirect
# Custom functions
# MetaboDirect version 1.0
# by Christian Ayala
#     based on scripts and functions by Nathalia Graf Grachet
# Licensed under the MIT license. See LICENSE.md file.
# 
# ***************************************************************

# Additional data ----

## Molecular class table ----
classification <- tribble(
  ~Class, ~OC_low, ~OC_high, ~HC_low, ~HC_high,
  'Lipid', 0, 0.3, 1.5, 2.5,
  'Unsat. HC', 0, 0.125, 0.8, 1.5,
  'Cond. HC', 0, 0.95, 0.2, 0.8,
  'Protein', 0.3, 0.55, 1.5, 2.3,
  'Amino sugar', 0.55, 0.7, 1.5, 2.2,
  'Carbohydrate', 0.7, 1.5, 1.5, 2.5,
  'Lignin', 0.125, 0.65, 0.8, 1.5,
  'Tannin', 0.65, 1.1, 0.8, 1.5, 
) %>% 
  mutate(label_x = (OC_low + OC_high) / 2,
         label_y = HC_high - 0.1)

## Compound class rectangles (for plotting of Van Krevelen diagrams) ----

class_rect <-  geom_rect(data = classification,
                         aes(xmin = OC_low,
                             xmax = OC_high,
                             ymin = HC_low,
                             ymax = HC_high),
                         color = 'black',
                         fill = NA,
                         linewidth = 1,
                         inherit.aes = FALSE, 
                         linetype = 'dashed')
rect_label <- geom_label(data = classification,
                         aes(x = label_x,
                             y = label_y,
                             label = Class),
                         inherit.aes = FALSE,
                         size = 3)

# Themes ----

custom_theme <- function(angle_x = 0){
  theme_bw() +
    theme(plot.title = element_text(face = 'bold', hjust = 0.5),
          axis.text.x = element_text(angle = angle_x, hjust = 1))
}

# Plotting functions ----

# ******************************************************************************
plot_van_krevelen <- function(df, color_by, facet_by = NA){
  color_by <- color_by
  p <- ggplot(df,
              aes(x = OC,
                  y = HC,
                  color = !!rlang::ensym(color_by))) +
    geom_point() +
    labs(x = 'O:C',
         y = 'H:C',
         title = paste0('Van Krevelen Diagram by ', color_by)) +
    class_rect  +
    rect_label +
    custom_theme()
  
  if(!is.na(facet_by)){
    facet_formula <- as.formula(paste0('~ ', facet_by))
    p <- p +
      facet_wrap(facet_formula)
  }
  
  return(p)
}

# ******************************************************************************
plot_density <- function(df, index, color_by, facet_col, facet_row = NA){
  index <- index
  color_by <- color_by
  p <- ggplot(df_longer,
              aes(x = !!rlang::ensym(index),
                  fill = !!rlang::ensym(color_by))) +
    geom_density(alpha = 0.7) +
    theme_bw() +
    labs(title = paste(index, 'density plot'),
         x = index) +
    custom_theme()
  
  if(is.na(facet_row)){
    facet_formula <- as.formula(paste0('~ ', facet_col))
    p <- p +
      facet_wrap(facet_formula)
  } else {
    facet_formula <- as.formula(paste0(facet_row, ' ~ ', facet_col))
    p <- p +
      facet_grid(facet_formula)
  }
  
  return(p)
}

# ******************************************************************************
plot_violin <- function(df, index, color_by, facet_by = NA, title){
  index <- index
  color_by <- color_by
  
  # Testing normality
  df_test <- df %>% 
    select(Mass, all_of(index)) %>% 
    distinct()
  pval <- try(shapiro.test(df_test[[index]])$p.value)
  
  # Comparing means
  stat_formula <- as.formula(paste0(index, '~ ', color_by))
  if(!is.na(facet_by)){
    stat_df <- df %>% 
      group_by(!!rlang::ensym(facet_by))
  } else stat_df <- df
  
  if(pval < 0.05 || str_detect(pval, 'Error')){
    stat_df <- stat_df %>% 
      dunn_test(stat_formula) %>% 
      add_significance() %>% 
      add_xy_position(step.increase = 1, scales = 'free_y')
  } else {
    stat_df <- stat_df %>% 
      tukey_hsd(stat_formula) %>% 
      add_significance() %>% 
      add_xy_position(step.increase = 1, scales = 'free_y')
  }
  
  p <- ggplot(df,
              aes(x = !!rlang::ensym(color_by),
                  y = !!rlang::ensym(index),
                  fill = !!rlang::ensym(color_by))) +
    geom_violin(alpha = 0.7) +
    geom_boxplot(width = 0.1, outlier.size = 0.2, show.legend = F) +
    theme_bw() +
    labs(title = title,
         x = color_by) +
    custom_theme(angle_x = 45)
  
  if(!is.na(facet_by)){
    facet_formula <- as.formula(paste0('~ ', facet_by))
    p <- p +
      stat_pvalue_manual(data = stat_df,
                         label = 'p.adj.signif', 
                         inherit.aes = FALSE,
                         hide.ns = TRUE) +
      facet_wrap(facet_formula)
  } else {
    p <- p +
      stat_pvalue_manual(data = stat_df,
                         label = 'p.adj.signif', 
                         inherit.aes = FALSE,
                         hide.ns = TRUE)
  }
  
  return(p)
}

# ******************************************************************************
plot_comp_bar <- function(df, composition, group, title){
  if(length(group) == 2){
    group_a <- group[1]
    group_b <- group[2]
    df <- df %>% 
      group_by(!!rlang::ensym(group_a), 
               !!rlang::ensym(group_b), 
               !!rlang::ensym(composition))
  } else {
    group_a <- group[1]
    df <- df %>% 
      group_by(!!rlang::ensym(group_a), 
               !!rlang::ensym(composition))
  }
  
  if(composition == 'Class'){
    colors <- class_colors
  } else {
    colors <- get_palette('Set3', length(unique(df$Element)))
  }
  
  plot <- df %>% 
    summarise(Count = mean(Count, na.rm = TRUE)) %>%
    mutate(Perc_count = Count/sum(Count, na.rm = TRUE)*100) %>%
    ggplot(aes(x = !!rlang::ensym(group_a),
               y = Perc_count,
               fill = !!rlang::ensym(composition))) +
    geom_col(color = 'black') +
    scale_fill_manual(values = colors) +
    labs(title = title,
         y = 'Percentage') +
    custom_theme()
  
  if(length(group) == 2){
    facet_formula <- as.formula(paste0('~ ', group_b))
    plot <- plot + 
      facet_wrap(facet_formula, scales = 'free_x')
  }
  return(plot)
}

# ******************************************************************************
plot_ordination <- function(df, x, y, color_by, col_vec, title, 
                            shape_by = NA, point_size = 2.5,
                            x_label = NA, y_label = NA){
  color_by <- color_by
  shape_by <- shape_by
  if(is.na(shape_by)){
    plot <- ggplot(df) +
      geom_point(aes(x = {{ x }},
                     y = {{ y }},
                     color = !!rlang::ensym(color_by)),
                 size = point_size)
  } else {
    plot <- ggplot(df) +
      geom_point(aes(x = {{ x }},
                     y = {{ y }},
                     color = !!rlang::ensym(color_by),
                     shape = !!rlang::ensym(shape_by)),
                 size = point_size)
  }
  
  plot <- plot + 
    scale_color_manual(values = col_vec) +
    labs(title = title) +
    custom_theme()
  
  return(plot)
}

# ******************************************************************************
plot_diversity_index <- function(df, group_by, title){
  group_by <- group_by
  
  plot <- df %>% 
    ggplot() +
    geom_boxplot(aes(x = !!rlang::ensym(group_by),
                     y = values,
                     fill = !!rlang::ensym(group_by))) +
    scale_fill_manual(values = my_colors) +
    facet_wrap(~index, scales = 'free_y') +
    labs(title = title) +
    custom_theme()
  
  return(plot)
}

# Calculate functions ----

# ******************************************************************************
select_masses <- function(df, group, value){
  group <- group
  df %>% 
    filter(!!rlang::ensym(group) == value) %>% 
    pull(Mass)
}

# ******************************************************************************
calculate_weighted <- function(df, index){
  new_names <- paste0(index, c('_weigthed', '_magnitude_average'))
  names(new_names) <- c('wt', 'm_avg')
  weighted_df <- df %>%  
    select(Mass, SampleID, NormIntensity, all_of(c(index))) %>% 
    mutate(wt = !!rlang::ensym(index) * NormIntensity) %>% 
    group_by(SampleID) %>% 
    mutate(m_avg = sum(wt, na.rm = TRUE)/sum(NormIntensity, na.rm = TRUE)) %>% 
    select(Mass,SampleID, all_of(index), wt, m_avg) %>% 
    rename_with(.cols = c(wt, m_avg), .fn = function(x) new_names[x]) %>% 
    pivot_longer(!c(SampleID, Mass), names_to = 'weighted_idx', values_to = 'value') %>% 
    left_join(metadata, by = 'SampleID') %>% 
    ungroup()
  
  return(weighted_df)
}

# ******************************************************************************
calculate_dist <- function(mat, normalized_with, dm_method = 'AUTO'){
  if(dm_method == 'AUTO'){
    if(norm_method %in% c('max', 'sum', 'none')){
      dm_method = 'bray'
    }else if(norm_method %in% c('mean', 'median', 'z_score', 'minmax')){
      dm_method = 'manhattan'
    }else {
      dm_method = 'jaccard'
    }
  }
  
  print(paste0('Using ', dm_method, ' distance'))
  
  vegdist(mat, method = dm_method)
  
}

# ******************************************************************************
calculate_nmds <- function(mat, normalized_with, 
                           dm_method = 'AUTO', seed = 123){
  dist_mat <- calculate_dist(mat, normalized_with, dm_method)
  
  set.seed(seed)
  nmds.log <- capture.output(nmds <- metaMDS(dist_mat, 
                                             k = 2,
                                             distance = dm_method,
                                             maxit = 999,
                                             trymax = 500,
                                             wascores = TRUE))
  filename <- file.path(my_outdir, '1.1_NMDS.log')
  write_lines(as.data.frame(nmds.log), filename)
  
  filename <- file.path(my_outdir, '1.2_NMDS_stressplot.png')
  
  png(filename, res = 300, height = 3600, width = 3600)
  capture.output(stressplot(nmds))
  dev.off()
  
  nmds_scores <- as.data.frame(scores(nmds, display = 'sites')) %>% 
    rownames_to_column(var = 'SampleID') %>% 
    left_join(metadata, by = 'SampleID')
  
}

# ******************************************************************************
calculate_permanova <- function(mat, normalized_with, variables,
                                dm_method = 'AUTO', seed = 123){
  
  dist_mat <- calculate_dist(mat, normalized_with, dm_method)
  set.seed(seed)
  
  formula <- as.formula(paste0('dist_mat ~', paste(variables, collapse = '+')))
  
  permanova <- adonis2(formula, 
                       data=metadata, 
                       permutations=999, 
                       method=dm.method)
  return(permanova)
}

# ******************************************************************************
calculate_pca <- function(mat){
  
  mat <- mat %>% 
    mutate(across(everything(), ~ifelse(is.na(.x), 0, .x)))
  
  pca <- prcomp(mat, center = TRUE)
  eigen <- get_eigenvalue(pca)
  
  scree_plot <- fviz_eig(pca, addlabels = TRUE) +
    theme_bw() +
    theme(plot.title = element_text(face = 'bold', hjust = 0.5))
  
  # Extract sample coordinates for PC1 and PC2
  pca_coordinates <- as_tibble(pca$x)
  pca_coordinates$SampleID <- rownames(pca$x)
  pca_coordinates <- left_join(pca_coordinates, metadata, by ='SampleID')
  
  var_loadings <- facto_summarize(pca, element = "var", 
                                  result=c("coord","contrib","cos2"), axes=c(1,2))
  
  return(list(coordinates = pca_coordinates,
              eigenvalues = eigen,
              scree_plot = scree_plot,
              loadings = var_loadings))
}

# ******************************************************************************
calculate_richness <- function(mat){
  richness <- specaccum(mat, method = 'random', permutations = 100)
  
  richness_long <- as_tibble(richness$perm, rownames = 'Sites') %>%
    pivot_longer(!Sites, names_to = 'permutation', values_to = 'Richness') %>%
    mutate(Sites = as.numeric(Sites))
  
  return(richness_long)
}

# ******************************************************************************
calculate_rank_abundance <- function(mat){
  rank_abundance <- tibble(peak = colnames(mat),
                           intensity_sums = colSums(mat),
                           presence = colSums(mat != 0)) %>%
    arrange(intensity_sums) %>%
    mutate(position = n():1,
           presence_perc = presence/nrow(mat)*100)
  
  return(rank_abundance)
}

# ******************************************************************************
calculate_diversity_index <- function(mat, norm_mat){
  diversity <- tibble(SampleID = rownames(norm_mat),
                      Shannon = diversity(norm_mat, index = 'shannon'),
                      Gini_Simpson = diversity(norm_mat, index = 'simpson'),
                      Chao1 = estimateR(round(mat))['S.chao1',])  
  
  filename <- file.path(my_outdir, '2.1_abundance_diversity_index.csv')
  write_csv(diversity, filename)
  
  final_df <- diversity %>% 
    pivot_longer(!SampleID, names_to = 'index', values_to = 'values') %>% 
    left_join(metadata, by = 'SampleID')
  
  return(final_df)
}

# ******************************************************************************
calculate_functional_div_index <- function(fun_df, mat){
  # Elemental composition
  el_traits <- fun_df %>% 
    select(Mass, C, H, O, N, S, P) %>% 
    column_to_rownames(var = 'Mass')
  
  # Reactivity
  rx_traits <- df %>% 
    select(Mass, NOSC)%>% 
    column_to_rownames(var = 'Mass')
  
  # Insaturation/aromaticity
  ia_traits <- df %>% 
    select(Mass, DBE, AI_mod)%>% 
    column_to_rownames(var = 'Mass')
  
  functional_diversity <- tibble(SampleID = rownames(mat),
                                 Elemental_composition = 
                                   rao.diversity(mat, el_traits)$FunRao,
                                 Reactivity = 
                                   rao.diversity(mat, rx_traits)$FunRao,
                                 Insaturation_and_aromaticity = 
                                   rao.diversity(mat, ia_traits)$FunRao) 
  
  filename <- file.path(my_outdir, '3.1_functional_diversity.csv')
  write_csv(functional_diversity, filename)
  
  final_df <- functional_diversity %>% 
    pivot_longer(!SampleID, names_to = 'index', values_to = 'values') %>% 
    left_join(metadata, by = 'SampleID') %>% 
  
  return(final_df)
  
}

# KEGG function ----

# ******************************************************************************
get_kegg_compound_info <- function(cpd_id, mass, formula){
  cpd_get <- keggGet(cpd_id)
  
  cpd_res <- map(cpd_get, function(entry){
    entry_df <- tibble(Mass = mass,
                       MolecularFormula = formula,
                       KEGG_id = entry$ENTRY,
                       KEGG_name = paste(entry$NAME, collapse = ';'),
                       KEGG_formula = entry$FORMULA,
                       KEGG_pathway = ifelse(!is.null(entry$PATHWAY), 
                                             paste(entry$PATHWAY, collapse = ';'), NA),
                       KEGG_module = ifelse(!is.null(entry$MODULE), 
                                            paste(entry$MODULE, collapse = ';'), NA),
                       KEGG_brite = ifelse(!is.null(entry$BRITE), 
                                           paste(entry$BRITE, collapse = ';'), NA),
                       KEGG_enzyme = ifelse(!is.null(entry$ENZYME), 
                                            paste(entry$ENZYME, collapse = ';'), NA),
                       KEGG_reaction = ifelse(!is.null(entry$REACTION), 
                                              paste(entry$REACTION, collapse = ';'), NA))
    
    return(entry_df)
  })
  
  cpd_df <- reduce(cpd_res, rbind)
  
  return(cpd_df)
}

# ##############################################################
# 
# MetaboDirect
# Data Normalization selection
# version 1.0
# by Christian Ayala
# 
# Licensed under the MIT license. See LICENSE.md file.
# 
# ##############################################################

suppressPackageStartupMessages({
  library(tidyverse)
  library(pmartR)
}) 

# Values between two '%' are to be replaced by the correct values during the python script

#### Defining paths and variables ####

setwd('%currentdir%')

my_metadata.file <- file.path('%metadata%')
my_data.file <- file.path('%data%')
source.file <- file.path('%Metabo_HOME%', 'spans.R')
log_transform <- %log%
group <- '%group%'

source(source.file)
metadata <- read.csv(my_metadata.file)
data <- read.csv(my_data.file) 
# data$Mass <- as.character(data$Mass)
  
data <- data %>% 
  select(Mass, all_of(metadata$SampleID)) %>% 
  pivot_longer(all_of(metadata$SampleID), names_to = 'SampleID', values_to = 'Intensity') %>% 
  filter(Intensity > 0) %>% 
  pivot_wider(names_from = 'SampleID', values_from = 'Intensity')

data <- as.data.frame(data)

# data[data == 0] <- 1

pepdata <- as.pepData(data, metadata, edata_cname = 'Mass', fdata_cname = 'SampleID')

if(log_transform){
  pepdata <- edata_transform(pepdata, 'log')
}

span_test <- modified_spans_procedure(pepdata, group = group, sig_thresh = 0.001)


spans <- span_test %>%
  mutate(y_axis = paste0(subset_method, ' ', parameters))

spans_hmp <- ggplot(spans) +
  geom_tile(aes(x = normalization_method,
                y = y_axis,
                fill = SPANS_score),
            color = 'white') +
  coord_fixed() +
  scale_fill_viridis_c() +
  labs(title = 'SPANS scores for different normalizations',
       x = 'Normalization methods',
       y = 'Subset method and subset parameter',
       fill = 'SPANS score')

filename <- 'SPANS_scores.png'
ggsave(filename, spans_hmp, dpi = 300)

# ***************************************************************
# 
# MetaboDirect
# Data Exploration step
# version 1.0
# by Christian Ayala
# Licensed under the MIT license. See LICENSE.md file.
# 
# ***************************************************************

# Loading libraries ----

library(tidyverse)
library(KEGGREST)


# Values between two '%' are to be replaced by the correct values during the python script

# Defining variables ----

current_dir <- '%currentdir%'
output_dir <- '%outdir%'

setwd('%currentdir%')

my_data.file <- file.path(output_dir, '1_preprocessing_output', 'Report_processed_MolecFormulas.csv')
my_outdir <- file.path(output_dir, '3_exploratory')

# Loading custom functions ----
source(file.path(output_dir, 'custom_functions.R'))

# Import data ----

df <-  read_csv(my_data.file, col_types = cols())

# Molecular formula annotation with KEGG database ----

kegg_searches <- map2(df$Mass[1:50], df$MolecularFormula[1:50], function(mass, formula){
  
  print(paste0('Searching formula: ', formula))
  
  cpd <- keggFind('compound', formula, 'formula')
  cpd <- cpd[which(cpd == formula)]
  cpd_id <- names(cpd)
  
  if(length(cpd_id) > 0 && length(cpd_id) <= 10){
    cpd_df <- get_kegg_compound_info(cpd_id, mass, formula)
    
  } else if(length(cpd_id) > 10){
    # Kegg get only gives back 10 compounds at the time
    id_chunks <- split(cpd_id, ceiling(seq_along(cpd_id)/10))
    
    cpd_chunks <- map(id_chunks, ~get_kegg_compound_info(.x, mass, formula))
    
    cpd_df <- reduce(cpd_chunks, rbind)
    
  } else {
    cpd_df <- tibble(Mass = mass,
                     MolecularFormula = formula,
                     KEGG_id = NA,
                     KEGG_name = NA,
                     KEGG_formula = NA,
                     KEGG_pathway = NA,
                     KEGG_module = NA,
                     KEGG_brite = NA,
                     KEGG_enzyme = NA,
                     KEGG_reaction = NA)
  }
  
  return(cpd_df)
  
})

compound_df <- reduce(kegg_searches, rbind)

filename <- file.path(my_outdir, '7_KEGG_annotation_results.csv')
write_csv(matching_compounds, filename)

# #############################################################
# 
# MetaboDirect
# Data Exploration step
# version 1.0
# by Christian Ayala
#     based on scripts and functions by Nathalia Graf Grachet
# Licensed under the MIT license. See LICENSE.md file.
# 
# #############################################################

suppressPackageStartupMessages({
  library(tidyverse)
  library(RColorBrewer)
  library(ggnewscale)
  library(ggpubr)
  library(rstatix)
  library(KEGGREST)
  library(vegan)
  library(UpSetR)
}) 

# Values between two '%' are to be replaced by the correct values during the python script

#### Defining paths and variables ####

setwd('%currentdir%')

my_data.file <- file.path('%outdir%', '1_preprocessing_output', 'Report_processed_MolecFormulas.csv')
my_metadata.file <- file.path('%metadata%')
my_elcomp.file <- file.path('%outdir%', '1_preprocessing_output', 'elemental_composition.csv')
my_classcomp.file <- file.path('%outdir%', '1_preprocessing_output', 'class_composition.csv')
classification.file <- file.path('%Metabo_HOME%', 'data', 'compound_class_table.csv')
my_outdir <- file.path('%outdir%', '3_exploratory')

#### Import data ####

df <-  read_csv(my_data.file, col_types = cols())
metadata <- read_csv(my_metadata.file, col_types = cols())
el_comp <- read_csv(my_elcomp.file, col_types = cols())
class_comp <- read_csv(my_classcomp.file, col_types = cols())
classification <- read_csv(classification.file, col_types = cols())

#### Reformat data files ####

### Change all metadata columns to factors to avoid problems at plotting

for(i in 2:ncol(metadata)){
  metadata[,i] <- factor(as_vector(metadata[,i])) 
}

# Intensity data file
df_longer <- df %>%
  pivot_longer(metadata$SampleID, names_to = 'SampleID', values_to = 'NormIntensity') %>% 
  filter(NormIntensity != 0)
df_longer <- left_join(df_longer, metadata, by = 'SampleID')

# Class composition
class_comp <- class_comp %>%
  pivot_longer(!SampleID, names_to = 'Class', values_to = 'Count')
class_comp <- left_join(class_comp, metadata, by = 'SampleID')

# Elemental composition
el_comp <- el_comp %>%
  pivot_longer(!SampleID, names_to = 'Element', values_to = 'Count')
el_comp <- left_join(el_comp, metadata, by = 'SampleID')


#### Plot - Van Krevelen Diagram ####

## Compound class rectangles (for plotting)

class_rect <-  geom_rect(data = classification,
                         aes(xmin = OC_low,
                             xmax = OC_high,
                             ymin = HC_low,
                             ymax = HC_high,
                             color = Class),
                         fill = NA,
                         size = 1.5,
                         inherit.aes = FALSE, 
                         linetype = 'dashed') 

## Set samples color names

my_colors <- get_palette('Dark2', length(unique(df_longer$%group1%)))
names(my_colors) <- unique(df_longer$%group1%) 

for(var in c('GFE', 'AI_mod', 'DBE')){
  var_s = syms(var)
  vk_plot <- ggplot(df_longer,
                    aes(x = OC,
                        y = HC,
                        color = (!!! var_s))) +
    geom_point() +
    theme_bw() +
    scale_color_viridis_c(direction = -1) +
    labs(x = 'O:C',
         y = 'H:C',
         title = paste0('Van Krevelen Diagram by ', var),
         color = var) +
    new_scale_color() +
    class_rect  +
    scale_color_manual(values = get_palette('d3', 8)) +
    theme(plot.title = element_text(face = 'bold', hjust = 0.5)) +
    facet_wrap(%group1% ~ %group2%)
  
  filename <- file.path(my_outdir, paste0('vk_', var, '.png'))
  ggsave(filename, vk_plot, dpi = 300, height = 8, width = 15)
}


#### Plot - Density Diagram ####

for(var in c('GFE', 'AI_mod', 'DBE')){
  var_s = syms(var)
  density_plot <- ggplot(df_longer,
                         aes(x = (!!! var_s),
                             fill = %group1%)) +
    geom_density(alpha = 0.7) +
    scale_fill_manual(values = my_colors) +
    theme_bw() +
    labs(title = paste(var, 'density plot'),
         x = var) +
    theme(plot.title = element_text(face = 'bold', hjust = 0.5)) +
    facet_wrap(%group1% ~ %group2%)
  
  filename <- file.path(my_outdir, paste0('density_plot_', var, '.png'))
  ggsave(filename, density_plot, dpi = 300, width = 8, height = 8)
}
#### Plot - Violin ####

for(var in c('GFE', 'AI_mod', 'DBE')){
  
  var_s = syms(var)
  formula <- formula(paste0(var, ' ~ %group1%'))
  stat.test <- df_longer %>% 
    group_by(%group2%) %>% 
    tukey_hsd(formula) %>% 
    add_y_position(step.increase = 1)
  
  violin_plot <- ggplot(df_longer,
                        aes(x = %group1%,
                            y = (!!! var_s),
                            fill = %group1%)) +
    geom_violin(alpha = 0.7) +
    geom_boxplot(width = 0.1, outlier.size = 0.2, show.legend = F) +
    scale_fill_manual(values = my_colors) +
    theme_bw() +
    stat_pvalue_manual(stat.test,
                       label = 'p.adj.signif', inherit.aes = FALSE,
                       hide.ns = TRUE) +
    labs(title = paste(var, 'violin plot'),
         y = var) +
    theme(plot.title = element_text(face = 'bold', hjust = 0.5)) +
    facet_grid(cols = vars(%group2%))
  
  filename <- file.path(my_outdir, paste0('violin_plot_', var, '.png'))
  ggsave(filename, violin_plot, dpi = 300, width = 8, height = 8)
}

#### Weighted Thermodynamical indices ####

# Magnitude-weighted values

for(var in c('GFE', 'AI_mod', 'DBE')){
  
  var_s = syms(var)
  newnames <- paste0(var, c('_weighted', '_magniture_average'))
  
  weighted_df <- df_longer %>%  
    mutate(w = (!!! var_s) * NormIntensity) %>% 
    select(Mass, SampleID, NormIntensity, !!! var_s, w) %>% 
    group_by(SampleID) %>% 
    add_tally(w, name = 'sum_w') %>% 
    add_tally(NormIntensity, name = 'sum_intensity') %>% 
    ungroup() %>% 
    mutate(m_avg = sum_w/sum_intensity) %>% 
    select(SampleID, !!! var_s, w, m_avg) %>% 
    rename(!!newnames[1] := w, !!newnames[2] := m_avg) %>% 
    pivot_longer(-SampleID, names_to = 'weighted_idx', values_to = 'value') %>% 
    left_join(metadata, by = 'SampleID')
  
  stat.test <- weighted_df %>%
    group_by(weighted_idx) %>% 
    tukey_hsd(value ~ %group1%) %>% 
    add_y_position(scales = 'free_y', step.increase = 1)
  
  weighted_plot <- ggplot(weighted_df) +
    geom_boxplot(aes(x = %group1%,
                     y = value,
                     fill = %group1%)) +
    stat_pvalue_manual(stat.test,
                       label = 'p.adj.signif', inherit.aes = FALSE,
                       hide.ns = TRUE) +
    facet_wrap(~weighted_idx, scales = 'free_y') +
    theme_bw() +
    labs(title = paste0(var, ' - Weighted abundance'),
         caption = '"_weighted" index are calculated by multiplying the index (i.e. GFE, DBE or IA) times
         the normalized intensity per each of the detected masses.
         "_magniture average" index are calculated by dividing
         the total sum of the "_weighted" index by the total sum of the normalized 
         intensities per each of the samples.') +
    theme(plot.title = element_text(face = 'bold', hjust = 0.5))
  
  filename <- file.path(my_outdir, paste0('weighted_abundance_',var, '.png'))
  ggsave(filename, weighted_plot, dpi = 300, width = 8, height = 8)
  
}

#### Plot - Class comp bar####

class_colors <- brewer.pal(length(classification$Class) + 1, name = 'Set3')
names(class_colors) <- c(classification$Class, 'Other')

class_bar <- class_comp %>% 
  group_by(%group1%, %group2%, Class)  %>% 
  summarise(Count = mean(Count, na.rm = TRUE)) %>%
  mutate(Perc_count = Count/sum(Count, na.rm = TRUE)*100) %>%
  ggplot(aes(x = %group1%,
             y = Perc_count,
             fill = Class)) +
  geom_col() +
  theme_bw() +
  scale_fill_manual(values = class_colors) +
  labs(title = 'Class Composition',
       y = 'Percentage') +
  theme(plot.title = element_text(face = 'bold', hjust = 0.5)) +
  facet_grid(cols = vars(%group2%))

filename <- file.path(my_outdir, 'Composition_by_class.png')
ggsave(filename, class_bar, dpi = 300, width = 8, height = 8)

#### Plot - Elemental comp bar####

element_colors <- get_palette(palette = 'Accent', length(unique(el_comp$Element)))
names(element_colors) <- unique(el_comp$Element)

el_bar <- el_comp %>% 
  group_by(%group1%, %group2%, Element)  %>% 
  summarise(Count = mean(Count, na.rm = TRUE)) %>% 
  mutate(Perc_count = Count/sum(Count, na.rm = TRUE)*100) %>%
  ggplot(aes(x = %group1%,
             y = Perc_count,
             fill = Element)) +
  geom_col() +
  theme_bw() +
  scale_fill_manual(values = element_colors) +
  labs(title = 'Elemental Composition',
       y = 'Percentage') +
  theme(plot.title = element_text(face = 'bold', hjust = 0.5)) +
  facet_grid(cols = vars(%group2%))

filename <- file.path(my_outdir, 'Composition_by_element.png')
ggsave(filename, el_bar, dpi = 300, width = 8, height = 8)

#### Comparisons ####

### Grouping variable 1

group1 <- '%group1%'
group1_s <- syms(group1)

comparison_dir <- file.path(my_outdir, paste0('Comparisons-', group1))
dir.create(comparison_dir)

## Group comparison

df_w <- df_longer %>% 
  pivot_wider(names_from = all_of(group1), values_from = all_of(group1), names_prefix = 'GRP_') %>% 
  select(Mass, HC, OC, contains('GRP_')) %>% 
  group_by(Mass) %>% 
  fill(contains('GRP_'), .direction = 'downup')  %>% 
  distinct() %>% 
  unite(Presence, contains('GRP_'), sep = ', ', na.rm = TRUE)

vk_plot <- ggplot(df_w,
                  aes(x = OC,
                      y = HC,
                      color = Presence)) +
  geom_point() +
  theme_bw() +
  scale_color_brewer(palette = 'Paired', guide = guide_legend(order = 2)) +
  new_scale_color() +
  class_rect  +
  scale_color_brewer(palette = 'Dark2', guide = guide_legend(order = 1)) +
  labs(x = 'O:C',
       y = 'H:C',
       title = paste0('Van Krevelen Diagram by ', group1)) +
  theme(plot.title = element_text(face = 'bold', hjust = 0.5))

filename <- file.path(comparison_dir, paste0('vk_', group1, '_all_data.png'))
ggsave(filename, vk_plot, dpi = 300, width = 8, height = 8)

## Upset plot all features group 1

group_list <- list()
i <- 1

for(val in unique(df_longer$'%group1%')){
  list_mass <- df_longer %>%
    filter((!!! group1_s) == val) %>% 
    pull(Mass)
  group_list[i] <- list(list_mass)
  i <- i + 1
}

names(group_list) <- unique(df_longer$'%group1%')

filename <- file.path(comparison_dir, paste0('upset_plot_', group1, '_all_data.png'))
png(filename, width = 2400, height = 2400, res = 300)
upset(fromList(group_list), order.by = "freq")
dev.off()

## Pairwise comparisons

# Get all combinations possible for group 1

comb_g1 <- combn(unique(df_longer$'%group1%'), 2)

my_colors <- c(get_palette('d3', length(unique(df_longer$'%group1%'))), 'gray80')
color_names <- c(unique(as.character(df_longer$'%group1%')), 'Shared')
names(my_colors) <- color_names

for(i in 1:ncol(comb_g1)){
  val1 <- as.character(comb_g1[1, i])
  val2 <- as.character(comb_g1[2, i])
  
  df_comb <- df_longer %>% 
    filter((!!! group1_s) == val1 | (!!! group1_s) == val2) %>% 
    pivot_wider(names_from = all_of(group1), values_from = all_of(group1), names_prefix = 'GRP_') %>% 
    select(Mass, HC, OC, Class, GFE, DBE, contains('GRP_')) %>% 
    group_by(Mass) %>% 
    fill(contains('GRP_'), .direction = 'downup')  %>% 
    distinct() %>% 
    unite(Presence, contains('GRP_'), sep = ', ', na.rm = TRUE) %>% 
    mutate(Presence = ifelse(str_detect(Presence, ', '), 'Shared', Presence))
  
  vk_plot <- ggplot(df_comb,
                    aes(x = OC,
                        y = HC,
                        color = Presence)) +
    geom_point() +
    theme_bw() +
    scale_color_manual(values = my_colors, guide = guide_legend(order = 1)) +
    new_scale_color() +
    class_rect  +
    scale_color_brewer(palette = 'Dark2', guide = guide_legend(order = 1)) +
    labs(x = 'O:C',
         y = 'H:C',
         title = 'Van Krevelen Diagram') +
    theme(plot.title = element_text(face = 'bold', hjust = 0.5),
          legend.position = 'bottom')
  
  stat.test <- df_comb %>%
    ungroup() %>% 
    tukey_hsd(GFE ~ Presence) %>% 
    add_y_position(step.increase = 1)
  
  
  violin_plot <- ggplot(df_comb,
                        aes(x = Presence,
                            y = GFE,
                            fill = Presence)) +
    geom_violin(alpha = 0.5) +
    geom_boxplot(width = 0.1, outlier.size = 0.2, show.legend = F) +
    scale_fill_manual(values = my_colors) +
    theme_bw() +
    labs(title = 'GFE') +
    stat_pvalue_manual(stat.test,
                       label = 'p.adj.signif', inherit.aes = FALSE,
                       hide.ns = TRUE) +
    theme(plot.title = element_text(face = 'bold', hjust = 0.5),
          legend.position = 'None',
          axis.title.x = element_blank())
  
  class_bar <- df_comb %>% 
    group_by(Presence)  %>% 
    count(Class) %>%
    mutate(count_perc=n/sum(n)*100) %>% 
    ggplot(aes(x = Presence,
               y = count_perc,
               fill = Class)) +
    geom_col() +
    theme_bw() +
    scale_fill_manual(values = class_colors) +
    labs(title = 'Class Composition') +
    theme(plot.title = element_text(face = 'bold', hjust = 0.5),
          axis.title = element_blank(),
          legend.position = 'bottom')
  
  combined_plot <- ggarrange(vk_plot, ggarrange(class_bar, violin_plot, nrow =2, align = 'v'), ncol = 2, widths = c(1.5, 1))
  combined_plot <- annotate_figure(combined_plot, top = text_grob(paste0(val1, ' vs ', val2), face = 'bold', size = 20))
  
  filename <- file.path(comparison_dir, paste0('combined_graph_', val1, '_vs_', val2, '.png'))
  ggsave(filename, combined_plot, dpi = 300, width = 18, height = 8)
  
  ## Upset plot
  
  list1 <- df_longer %>% 
    filter((!!! group1_s) == val1) %>% 
    pull(Mass)
  
  list2 <- df_longer %>% 
    filter((!!! group1_s) == val2) %>% 
    pull(Mass)
  
  group_list <- list(list1, list2)
  names(group_list) <- c(val1, val2)
  
  filename <- file.path(comparison_dir, paste0('upset_plot_', val1, '_vs_', val2, '.png'))
  png(filename, width = 2400, height = 2400, res = 300)
  print(upset(fromList(group_list), order.by = "freq"))
  dev.off()
}

## Grouping variable 2

group2 <- '%group2%'

if(group2 != 'NULL'){
group2_s <- syms(group2)

comparison_dir <- file.path(my_outdir, paste0('Comparisons-', group2))
dir.create(comparison_dir)


  df_w <- df_longer %>% 
    pivot_wider(names_from = all_of(group2), values_from = all_of(group2), names_prefix = 'GRP_') %>% 
    select(Mass, HC, OC, contains('GRP_')) %>% 
    group_by(Mass) %>% 
    fill(contains('GRP_'), .direction = 'downup')  %>% 
    distinct() %>% 
    unite(Presence, contains('GRP_'), sep = ', ', na.rm = TRUE)
  
  vk_plot <- ggplot(df_w,
                    aes(x = OC,
                        y = HC,
                        color = Presence)) +
    geom_point() +
    theme_bw() +
    scale_color_brewer(palette = 'Paired') +
    new_scale_color() +
    class_rect  +
    scale_color_brewer(palette = 'Dark2') +
    labs(x = 'O:C',
         y = 'H:C',
         title = paste0('Van Krevelen Diagram by ', group2)) +
    theme(plot.title = element_text(face = 'bold', hjust = 0.5))
  
  filename <- file.path(comparison_dir, paste0('VK_', group2, '_all_data.png'))
  ggsave(filename, vk_plot, dpi = 300, width = 8, height = 8)
  
  ## Upset plot all features group 2
  
  group_list <- list()
  i <- 1
  
  for(val in unique(df_longer$'%group2%')){
    list_mass <- df_longer %>%
      filter((!!! group2_s) == val) %>% 
      pull(Mass)
    group_list[i] <- list(list_mass)
    i <- i + 1
  }
  
  names(group_list) <- unique(df_longer$'%group2%')
  
  filename <- file.path(comparison_dir, paste0('upset_plot_', group2, '_all_data.png'))
  png(filename, width = 2400, height = 2400, res = 300)
  print(upset(fromList(group_list), order.by = "freq"))
  dev.off()
  
  
  ## Pairwise comparisons
  
  # Get all combinations possible for group 2
  
  comb_g2 <- combn(unique(df_longer$'%group2%'), 2)
  
  my_colors <- c(get_palette('d3', length(unique(df_longer$'%group2%'))), 'gray80')
  color_names <- c(unique(as.character(df_longer$'%group2%')), 'Shared')
  names(my_colors) <- color_names
  
  
  for(i in 1:ncol(comb_g2)){
    val1 <- as.character(comb_g2[1, i])
    val2 <- as.character(comb_g2[2, i])
    
    df_comb <- df_longer %>% 
      filter((!!! group2_s) == val1 | (!!! group2_s) == val2) %>% 
      pivot_wider(names_from = all_of(group2), values_from = all_of(group2), names_prefix = 'GRP_') %>% 
      select(Mass, HC, OC, Class, GFE, DBE, contains('GRP_')) %>% 
      group_by(Mass) %>% 
      fill(contains('GRP_'), .direction = 'downup')  %>% 
      distinct() %>% 
      unite(Presence, contains('GRP_'), sep = ', ', na.rm = TRUE) %>% 
      mutate(Presence = ifelse(str_detect(Presence, ', '), 'Shared', Presence))
    
    vk_plot <- ggplot(df_comb,
                      aes(x = OC,
                          y = HC,
                          color = Presence)) +
      geom_point() +
      theme_bw() +
      scale_color_manual(values = my_colors, guide = guide_legend(order = 2)) +
      new_scale_color() +
      class_rect  +
      scale_color_brewer(palette = 'Dark2', guide = guide_legend(order = 1)) +
      labs(x = 'O:C',
           y = 'H:C',
           title = 'Van Krevelen Diagram') +
      theme(plot.title = element_text(face = 'bold', hjust = 0.5),
            legend.position = 'bottom')
    
    stat.test <- df_comb %>%
      ungroup() %>% 
      tukey_hsd(GFE ~ Presence) %>% 
      add_y_position(step.increase = 1)
    
    
    violin_plot <- ggplot(df_comb,
                          aes(x = Presence,
                              y = GFE,
                              fill = Presence)) +
      geom_violin(alpha = 0.5) +
      geom_boxplot(width = 0.1, outlier.size = 0.2, show.legend = F) +
      scale_fill_manual(values = my_colors) +
      theme_bw() +
      labs(title = 'GFE') +
      stat_pvalue_manual(stat.test,
                         label = 'p.adj.signif', inherit.aes = FALSE,
                         hide.ns = TRUE) +
      theme(plot.title = element_text(face = 'bold', hjust = 0.5),
            legend.position = 'None',
            axis.title.x = element_blank())
    
    class_bar <- df_comb %>% 
      group_by(Presence)  %>% 
      count(Class) %>%
      mutate(count_perc=n/sum(n)*100) %>% 
      ggplot(aes(x = Presence,
                 y = count_perc,
                 fill = Class)) +
      geom_col() +
      theme_bw() +
      scale_fill_manual(values = class_colors) +
      labs(title = 'Class Composition') +
      theme(plot.title = element_text(face = 'bold', hjust = 0.5),
            axis.title = element_blank(),
            legend.position = 'bottom')
    
    combined_plot <- ggarrange(vk_plot, ggarrange(class_bar, violin_plot, nrow =2, align = 'v'), ncol = 2, widths = c(1.5, 1))
    combined_plot <- annotate_figure(combined_plot, top = text_grob(paste0(val1, ' vs ', val2), face = 'bold', size = 20))
    
    filename <- file.path(comparison_dir, paste0('combined_graph_', val1, '_vs_', val2, '.png'))
    ggsave(filename, combined_plot, dpi = 300, width = 18, height = 8)
    
    ## Upset plot
    
    list1 <- df_longer %>% 
      filter((!!! group2_s) == val1) %>% 
      pull(Mass)
    
    list2 <- df_longer %>% 
      filter((!!! group2_s) == val2) %>% 
      pull(Mass)
    
    group_list <- list(list1, list2)
    names(group_list) <- c(val1, val2)
    
    filename <- file.path(comparison_dir, paste0('upset_plot_', val1, '_vs_', val2, '.png'))
    png(filename, width = 2400, height = 2400, res = 300)
    print(upset(fromList(group_list), order.by = "freq"))
    dev.off()
  }
  
}

# ***************************************************************
# 
# MetaboDirect
# Data Exploration step
# MetaboDirect version 1.0
# by Christian Ayala
#     based on scripts and functions by Nathalia Graf Grachet
# Licensed under the MIT license. See LICENSE.md file.
# 
# ***************************************************************

# Loading libraries ----

library(ggvenn)
library(RColorBrewer)
library(ggpubr)
library(rstatix)
library(vegan)
library(UpSetR)
library(tidyverse)

# Defining variables ----

current_dir <- '%currentdir%'
output_dir <- '%outdir%'
group1 <- '%group1%'
group2 <- '%group2%'

setwd(current_dir)

# Loading custom functions ----
source(file.path(output_dir, 'custom_functions.R'))

class_colors <- get_palette(palette = 'Set3', k = 9)
names(class_colors) <- c(classification$Class, 'Other')


# Import data ----

## Defining paths
my_data.file <- file.path(output_dir, '1_preprocessing_output', 'Report_processed_MolecFormulas.csv')
my_metadata.file <- file.path('%metadata%')
my_elcomp.file <- file.path(output_dir, '1_preprocessing_output', 'elemental_composition.csv')
my_classcomp.file <- file.path(output_dir, '1_preprocessing_output', 'class_composition.csv')
my_outdir <- file.path(output_dir, '3_exploratory')

## Loading tables
df <- read_csv(my_data.file)
metadata <- read_csv(my_metadata.file)
el_comp <- read_csv(my_elcomp.file)
class_comp <- read_csv(my_classcomp.file)

# Reformat data files ----

## Change all metadata columns to factors to avoid problems at plotting

metadata <- metadata %>% 
  mutate(across(!SampleID, as.factor))

## Intensity data file
df_longer <- df %>%
  pivot_longer(metadata$SampleID, names_to = 'SampleID', values_to = 'NormIntensity') %>% 
  filter(NormIntensity != 0) %>% 
  left_join(metadata, by = 'SampleID')

## Class composition
class_comp <- class_comp %>%
  pivot_longer(!SampleID, names_to = 'Class', values_to = 'Count') %>% 
  left_join(metadata, by = 'SampleID')

## Elemental composition
el_comp <- el_comp %>%
  pivot_longer(!SampleID, names_to = 'Element', values_to = 'Count') %>% 
  left_join(metadata, by = 'SampleID')

# Plotting ----

## setting colors for grouping variable ----

my_colors <- set_names(get_palette('Dark2', length(unique(metadata[[group1]]))),
                       nm = unique(metadata[[group1]]))

## Setting list of indexes to plot ----
thermo_idx <- set_names(c('GFE', 'AI_mod', 'DBE', 'NOSC'),
                        nm = c('GFE', 'AI_mod', 'DBE', 'NOSC'))

## Van Krevelen plot ----
vk_plots <- map(thermo_idx, ~ plot_van_krevelen(df_longer, color_by = .x, facet_by = group1) + 
                  scale_color_viridis_c(direction = -1))

plot_filenames <- file.path(my_outdir, paste0('1.', 1:4, '_van_krevelen_', thermo_idx,'.png'))
walk2(vk_plots, plot_filenames, ~ggsave(.y, .x, dpi = 300, width = 12, height = 6))

## Density plot ----
density_plots <- map(thermo_idx, ~ plot_density(df_longer,
                                                index = .x,
                                                color_by = group1,
                                                facet_col = group1,
                                                facet_row = group2) +
                       scale_fill_manual(values = my_colors))


plot_filenames <- file.path(my_outdir, paste0('2.', 1:4, '_density_plot_', thermo_idx,'.png'))
walk2(density_plots, plot_filenames, ~ggsave(.y, .x, dpi = 300, width = 12, height = 6))

## Violin plot ----

violin_plots <- map(thermo_idx, ~ plot_violin(df_longer,
                                              index = .x,
                                              color_by = group1,
                                              facet_by = group2,
                                              title = .x) +
                      scale_fill_manual(values = my_colors))

plot_filenames <- file.path(my_outdir, paste0('3.', 1:4, '_violin_plot_', thermo_idx,'.png'))
walk2(violin_plots, plot_filenames, ~ggsave(.y, .x, dpi = 300, width = 12, height = 6))

## Weighted Thermodynamical indices ----

# Magnitude-weighted values

wt_df <- map(thermo_idx, ~ calculate_weighted(df_longer, index = .x))
wt_violins <- imap(wt_df, ~ plot_violin(df = .x,
                                        index = 'value',
                                        color_by = group1,
                                        facet_by = 'weighted_idx',
                                        title = .y) +
                     scale_fill_manual(values = my_colors))

plot_filenames <- file.path(my_outdir, paste0('4.', 1:4, '_weighted_index_', thermo_idx,'.png'))
walk2(wt_violins, plot_filenames, ~ggsave(.y, .x, dpi = 300, width = 12, height = 6))

## Plot - Class comp bar ----

class_bar <- plot_comp_bar(class_comp, composition = 'Class',
                           group = c(group1, group2), title = 'Molecular Class')

filename <- file.path(my_outdir, '5_Composition_by_class.png')
ggsave(filename, class_bar, dpi = 300, width = 8, height = 8)

## Plot - Elemental comp bar ----

el_bar <- plot_comp_bar(el_comp, composition = 'Element',
                        group = c(group1, group2), title = 'Elemental Composition')

filename <- file.path(my_outdir, '6_Composition_by_element.png')
ggsave(filename, el_bar, dpi = 300, width = 8, height = 8)

# Comparisons ----

groups <- c(group1, group2)

walk(groups, function(g){
  
  comparison_dir <- file.path(my_outdir, paste0('Comparisons-', g))
  if(!dir.exists(comparison_dir)) dir.create(comparison_dir)
  
  df_group <- df_longer %>% 
    select(Mass, HC, OC, Presence = all_of(g)) %>% 
    distinct() %>% 
    group_by(Mass, HC, OC) %>% 
    arrange(Presence) %>% 
    summarise(Presence = paste0(Presence, collapse = ','))
  
  vk_plot <- plot_van_krevelen(df_group, color_by = 'Presence')
  
  filename <- file.path(comparison_dir, paste0('1_vk_', g, '_all_data.png'))
  ggsave(filename, vk_plot, dpi = 300, width = 8, height = 8)
  
  ## Upset plot all features group 1
  
  group_values <- unique(df_longer[[g]])
  mass_list <- map(group_values, ~select_masses(df_longer, group = g, value = .x))
  names(mass_list) <- group_values
  
  filename <- file.path(comparison_dir, paste0('2_upset_plot_', g, '_all_data.png'))
  png(filename, width = 2400, height = 2400, res = 300)
  print(upset(fromList(mass_list), order.by = "freq"))
  dev.off()
  
  ## Pairwise comparisons
  
  comb <- combn(unique(as.character(df_longer[[g]])), 2)
  comb_colors <- set_names(c(get_palette('Dark2', length(unique(df_longer[[g]]))), 'gray80'),
                         nm = c(unique(as.character(df_longer[[g]])), 'Shared'))
  
  walk2(comb[1,], comb[2,], function(val1, val2){
    filt_colors <- comb_colors[c(val1, val2, 'Shared')]
    
    df_comparisons <- df_longer %>% 
      rename(Presence = all_of(g)) %>% 
      filter(Presence %in% c(val1, val2)) %>% 
      group_by(Mass, HC, OC, GFE, Class) %>% 
      arrange(Presence) %>% 
      summarise(Presence = paste0(Presence, collapse = ',')) %>% 
      mutate(Presence = ifelse(str_detect(Presence, ','), 'Shared', Presence),
             Presence = factor(Presence, levels = c(val1, val2, 'Shared'))) %>% 
      ungroup()
    
    vk_comb <- plot_van_krevelen(df_comparisons, color_by = 'Presence') +
      scale_color_manual(values = filt_colors)
    
    violin_comb <- plot_violin(df_comparisons, index = 'GFE', color_by = 'Presence', 
                               title = 'Comparing GFE') +
      scale_fill_manual(values = filt_colors)
    
    class_comb <- df_comparisons %>% 
      group_by(Presence) %>% 
      count(Class, name = 'Count') %>% 
      plot_comp_bar(df = ., composition = 'Class', group = 'Presence', 
                    title = 'Molecular Class')
    
    combined <- ggarrange(vk_comb, ggarrange(violin_comb, class_comb, nrow = 2, align = 'v'),
                          ncol = 2, widths = c(1.5, 1)) %>% 
      annotate_figure(., top = text_grob(paste0(val1, ' vs ', val2), face = 'bold', size = 20))
    
    filename <- file.path(comparison_dir, paste0('combined_graph_', val1, '_vs_', val2, '.png'))
    ggsave(filename, combined, dpi = 300, width = 18, height = 8)
    
    # Getting masses
    mass_list <- map(c(val1, val2), ~select_masses(df_longer, group = g, value = .x))
    names(mass_list) <- c(val1, val2)
    
    # Upset
    filename <- file.path(comparison_dir, paste0('upset_plot_', val1, '_vs_', val2, '.png'))
    png(filename, width = 2400, height = 2400, res = 300)
    print(upset(fromList(mass_list), order.by = "freq"))
    dev.off()
    
    venn_plot <- ggvenn(mass_list, fill_color = as.character(filt_colors[1:2])) +
      labs(title = 'Number of metabolites (assigned molecular formula)') +
      theme(plot.title = element_text(face = 'bold', hjust = 0.5))
    
    filename <- file.path(comparison_dir, paste0('venn_diagram_', val1, '_vs_', val2, '.png'))
    ggsave(filename, venn_plot, dpi = 300, width = 7, height = 5, bg = 'white')
    
  })
  
})

# ***************************************************************
# 
# MetaboDirect
# Data Statistics step
# MetaboDirect version 1.0
# by Christian Ayala
#     based on scripts and functions by Nathalia Graf Grachet
# Licensed under the MIT license. See LICENSE.md file.
# 
# ***************************************************************

library(tidyverse)
library(vegan)
library(factoextra)
library(ggrepel)
library(ggpubr)
library(ggnewscale)


# Values between two '%' are to be replaced by the correct values during the python script

# Defining variables ----

current_dir <- '%currentdir%'
output_dir <- '%outdir%'
group1 <- '%group1%'

setwd(current_dir)

# Loading custom functions ----
source(file.path(output_dir, 'custom_functions.R'))

# Import data ----

## Defining paths
my_matrix.file <- file.path(output_dir, '1_preprocessing_output', 'matrix_features.csv')
my_report.file <- file.path(output_dir, '1_preprocessing_output', 'Report_processed_MolecFormulas.csv')
my_classcomp.file <- file.path(output_dir, '1_preprocessing_output', 'class_composition.csv')
my_metadata.file <- file.path('%metadata%')
my_outdir <- file.path(output_dir, '5_statistics')

norm_method <- '%norm_method%'

## Loading tables
matrix <-  read_csv(my_matrix.file) %>% 
  column_to_rownames(var = 'Mass')%>% 
  t()
class_comp <- read_csv(my_classcomp.file) %>% 
  column_to_rownames(var = 'SampleID')
metadata <- read_csv(my_metadata.file)
df <- read_csv(my_report.file)

# Reformat data files ----

## Change all metadata columns to factors to avoid problems at plotting

metadata <- metadata %>% 
  mutate(across(!SampleID, as.factor))

## Intensity data file

matrix <- matrix[metadata$SampleID,]

# Set samples color names ----

my_colors <- set_names(get_palette('Dark2', length(unique(metadata[[group1]]))),
                       nm = unique(metadata[[group1]]))

# NMDS ----

nmds_scores <- calculate_nmds(matrix, normalized_with = norm_method)

filename <- file.path(my_outdir, '1.3_nmds_scores.csv')
write_csv(nmds_scores, filename)

## NMDS plot ----

nmds_plot <- plot_ordination(nmds_scores, x = NMDS1, y = NMDS2,
                             color_by = group1, col_vec = my_colors,
                             title = 'NMDS Ordination') 

filename <- file.path(my_outdir, '1.4_NMDS_plot.png')
ggsave(filename, nmds_plot, dpi = 300, width = 6, height = 4)

# PERMANOVA ----

permanova <- calculate_permanova(matrix, normalized_with = norm_method,
                                 variables = group1)

permanova_table <- data.frame(permanova) %>% 
  rownames_to_column(var = 'Variable')

filename <- file.path(my_outdir, '2.1_permanova.csv')
write.csv(permanova_table, filename, row.names = TRUE)

# PCA of Compound classes ----

pca_class <- calculate_pca(class_comp)

## Saving data table with PCA eigenvalues

filename <- file.path(my_outdir, '3.1_eigen_values_by_compound_class.csv')
write_csv(pca_class$eigenvalues, filename)

## Saving data table with PCA screeplot

filename <- file.path(my_outdir, '3.2_scree_plot_by_compound_class.png')
ggsave(filename, pca_class$scree_plot, dpi = 300, width = 6, height = 4.5)

## Saving data table with PCA coordinates

filename <- file.path(my_outdir, '3.3_pca_coordinates_by_compound_class.csv')
write_csv(pca_class$coordinates, filename)

## PCA_plot Compound classes ----

## Variables with axis names

pc1 <- paste0('PC1 (', 
              round(pca_class$eigenvalues$variance.percent[1], digits = 1), '%)')
pc2 <- paste0('PC2 (', 
              round(pca_class$eigenvalues$variance.percent[2], digits = 1), '%)')

pca_plot <- plot_ordination(pca_class$coordinates, x = PC1, y = PC2,
                            color_by = group1, col_vec = my_colors,
                            title = 'PCA Compound Classes') +
  labs(x = pc1,
       y = pc2) +
  new_scale_color() +
  geom_segment(data = pca_class$loadings,
               aes(x = 0,
                   y = 0,
                   xend = Dim.1 * 2,
                   yend = Dim.2 * 2,
                   color = name), 
               inherit.aes = FALSE,
               arrow = arrow(length = unit(0.03, 'npc')),
               linewidth = 0.8,
               show.legend = FALSE) +
  geom_text_repel(data = pca_class$loadings,
                           aes(x = ifelse(Dim.1 * 2 > 0, Dim.1 * 2 + 1, Dim.1 * 2 - 1),
                               y = ifelse(Dim.2 * 2 > 0, Dim.2 * 2 + 1, Dim.2 * 2 - 1),
                               label = name,
                               color = name),
                           inherit.aes = FALSE,
                           hjust = 'inward',
                           show.legend = FALSE)

filename <- file.path(my_outdir, '3.4_PCA_plot_by_compound_class.png')
ggsave(filename, pca_plot, dpi = 300, width = 6, height = 4)

# PCA by molecular characteristics ----

## Getting dataframe with molecular characteristics ----

mol_char <- df %>%
  pivot_longer(metadata$SampleID, names_to = 'SampleID', values_to = 'NormIntensity') %>% 
  filter(NormIntensity != 0) %>% 
  select(NormIntensity, OC, HC, NOSC, GFE, DBE, AI_mod, SampleID) %>% 
  pivot_longer(!c(SampleID, NormIntensity), names_to = 'index', values_to = 'value') %>% 
  mutate(w_value = value * NormIntensity) %>% 
  group_by(SampleID, index) %>% 
  summarise(w_avg = sum(w_value, na.rm = TRUE) / sum(NormIntensity, na.rm = TRUE)) %>% 
  pivot_wider(names_from = 'index', values_from = 'w_avg') %>% 
  column_to_rownames(var = 'SampleID')

pca_molchar <- calculate_pca(mol_char)

## Saving data table with PCA eigenvalues

filename <- file.path(my_outdir, '4.1_eigen_values_by_molecular_characteristics.csv')
write_csv(pca_molchar$eigenvalues, filename)

## Saving data table with PCA screeplot

filename <- file.path(my_outdir, '4.2_scree_plot_by_molecular_characteristics.png')
ggsave(filename, pca_molchar$scree_plot, dpi = 300, width = 6, height = 4.4)

## Saving data table with PCA coordinates

filename <- file.path(my_outdir, '4.3_pca_coordinates_by_molecular_characteristics.csv')
write_csv(pca_molchar$coordinates, filename)

## PCA_plot Compound classes ----

## Variables with axis names

pc1 <- paste0('PC1 (', 
              round(pca_molchar$eigenvalues$variance.percent[1], digits = 1), '%)')
pc2 <- paste0('PC2 (', 
              round(pca_molchar$eigenvalues$variance.percent[2], digits = 1), '%)')

pca_plot <- plot_ordination(pca_molchar$coordinates, x = PC1, y = PC2,
                            color_by = group1, col_vec = my_colors,
                            title = 'PCA Molecular Characteristics') +
  labs(x = pc1,
       y = pc2) +
  new_scale_color() +
  geom_segment(data = pca_molchar$loadings,
               aes(x = 0,
                   y = 0,
                   xend = Dim.1 * 2,
                   yend = Dim.2 * 2,
                   color = name), 
               inherit.aes = FALSE,
               arrow = arrow(length = unit(0.03, 'npc')),
               linewidth = 0.8,
               show.legend = FALSE) +
  geom_text_repel(data = pca_molchar$loadings,
                           aes(x = ifelse(Dim.1 * 2 > 0, Dim.1 * 2 + 1, Dim.1 * 2 - 1),
                               y = ifelse(Dim.2 * 2 > 0, Dim.2 * 2 + 1, Dim.2 * 2 - 1),
                               label = name,
                               color = name),
                           inherit.aes = FALSE,
                           hjust = 'inward',
                           show.legend = FALSE)

filename <- file.path(my_outdir, '4.4_PCA_plot_by_compound_class.png')
ggsave(filename, pca_plot, dpi = 300, width = 6, height = 4)

# User Guide for MetaboDirect

## Introduction

**MetaboDirect** is a Python and R based pipeline for the analysis of Direct Injection FT-ICR Mass Spectrometry data.
The MetaboDirect pipeline takes a Formularity (Tolić et al., 2017) *report* and a *sample information* file as inputs and automatically performs all the analysis described below including: sample filtering, m/z filtering, normalization of intensities, thermodynamic index calculation, annotation of molecular formulas using the KEGG database (Kanehisa & Goto, 2000), statistical analysis and construction of transformation networks using Cytoscape (Shannon et al., 2003).

An companion script `test_normalization.py` is included to help selecting the best normalization method, and should be run before the main MetaboDirect pipeline. For more information about the companion script check the section: **(Optional Step) Test normalization methods**

## Quick Start

To quickly run the MetaboDirect pipeline use the following command. Read below for a more detailed information about the *input data* and the analysis options that are offered.

```
metabodirect DATA_FILE METADATA_FILE -g GROUPING_VARIABLE
```
Information about the arguments can be obtained using the -h/--help function.

```
metabodirect -h
```

```
usage: metabodirect [-h] [-o OUTDIR] [-m INT INT] -g STR [STR ...] [-f STR STR] [-b STR] [-t] [-k] [-n STR] [--norm_subset STR] [--subset_parameter FLOAT] [--log_transform] DATA METADATA

Program for running all the MetaboDirect analysis pipeline

positional arguments:
  DATA                  Name of the file with the DI-MS data in .csv format
  METADATA              Name of the file with the sample information (metadata) in .csv format

optional arguments:
  -h, --help            show this help message and exit
  -o OUTDIR, --outdir OUTDIR
                        Output directory (default: MetaboDirect_output)
  -m INT INT, --mass_filter INT INT
                        Range to filter m/z data (min_mz, max_mz). The pipeline will not filter m/z values by default (default: None)
  -g STR [STR ...], --group STR [STR ...]
                        Grouping variables for coloring and faceting figures (Max 2) (default: None)
  -f STR STR, --filter_by STR STR
                        Filter samples based on metadata. First enter the name of the feature,followed by the values associated with the samples you want to keep in the analysis.(Example -f Habitat Bog,Palsa)
                        (default: None)
  -b STR, --biochem_key STR
                        File with the biochemical key to use for the transformation network (default: Default key)
  -t, --transformation_analysis
                        Set this option to perform a transformation network analysis of the samples (default: False)
  -k, --kegg_annotation
                        Set this option to perform annotation of the molecular formulas usingthe KEGG database (default: False)

Normalization methods:
  Options to define how data normalization will be carried out

  -n STR, --norm_method STR
                        Available methods to normalize data are: 'mean', 'median', 'zscore', 'sum', 'max', 'minmax', 'binary', 'none' (default: max)
  --norm_subset STR     Subset of the data to use for normalization purpouses. Available subset methods: ALL, LOS, PPPLOS uses peaks in the top L order statistics, PPP uses peaks having a minimum percentage of
                        observed values. (default: ALL)
  --subset_parameter FLOAT
                        If using a sample subset for nomalization, this parameter defines the subsample of peaks that will be used for normalization.If not defined, the default values will be 0.3 for LOS and
                        0.5 for PPP (default: None)
  --log_transform       Set this option to log transform the data. (Program will fail if there are peaks with intensities of 0. Consider tranforming this values into 1 if log transformation is desired
                        (default: False)
```

#### Example using test data

```
metabodirect /path/to/MetaboDirect/metabodirect/data/Report.csv /path/to/MetaboDirect/metabodirect/data/metadata.csv -o test -m 200 400 -g Habitat Depth -f Testing Yes -t -k  
```

## MetaboDirect arguments

**MetaboDirect** requires two files, a report from Formularity (data file) and a sample information file (metadata file), and at least one grouping variable (defined in the metadata file).

#### Input data file

The input data for **MetaboDirect** is the a .csv report generated by default by Formularity. If Formularity was not used, the data file should be arranged to have columns with the **exact same names** that are shown below. 
*Mass1, Mass2, ...* refer to the m/z values detected by the software (i.e. each peak) while *Sample1, Sample2, ..* refer to the intesity of each peak for each of the samples.
An example dataset is included in the `/path/to/MetaboDirect/metabodirect/data/` directory with the name `Report.csv`.

|Mass|C|H|O|N|C13|S|P|Na|El_comp|Class|NeutralMass|Error_ppm|Candidates|*Sample1*|*Sample2*|*Sample3*|*...*|
|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|
|*Mass1*|4|4|4|4|0|0|0|0||NA|111.634719|0|NA|6.237|0|0|
|*Mass2*|5|2|2|0|0|0|0|0||NA|111.712035|0|NA|0|6.343|6.166|
|*Mass3*|3|6|2|2|0|1|0|0||NA|112.125136|0|NA|7.549|7.363|6.75|
|*Mass4*|5|6|3|0|0|0|1|0||NA|112.3957945|0|NA|0|0|6.145|
|*Mass5*|6|2|3|0|0|0|1|0||NA|112.457043|0|NA|0|6.133|0|
|*...*|||||||||||||||||

#### Sample information file

The sample information file (or metadata file) is a .csv file that has one column called *SampleID* with the names of all of the samples that are present in the report file. Please make sure that the sample names in the *input data* and the *sample information file* are **exactly the same**. At least one other column must be present in the sample information file and must contain information used to group the data for plotting and for the statistical analysis. Multiple grouping variables can be present in this file but only two can be used simultaneously in **MetaboDirect**. When running the pipelines the grouping variables can be defined with the `-g` option using the **exact name** that it is on this file.  Additionally, please use only letters (Aa-Zz), numbers (0-9) and underscores (\_) for both the **sample names** and the **grouping variables**.
An example file is included in the `/path/to/MetaboDirect/metabodirect/data/` directory with the name `metadata.csv`.

|SampleID|Grouping_var1|Grouping_var2|Grouping_var3
|---|---|---|---|
|*Sample1*|A|M|X|
|*Sample2*|A|N|Y|
|*Sample3*|B|M|Y|
|*Sample4*|B|N|X|
|*Sample5*|A|N|Z|

#### Output directory (-o/--outdir)

The name of directory where all the generated plots, tables and scripts will be saved. If it is not defined the directory will be names MetaboDirect_output by default

#### Grouping variable (-g/--group)

This option accepts up to two grouping variables (e.g. `-g Grouping_var1` or `-g Grouping_var1 Grouping_var2`) whose names are **exactly the same** as they appear in the columns of the metadafile. The first grouping variable will be used for giving colors to the plots generated. Both variables will be used for the statistical analysis and the pairwise comparisons.

#### Filter samples (-f/--filter_by)

This option takes two arguments: (a) a variable from the metadata file and (b) values from that variable column that we want to keep in the analysis. For example `-f Grouping_var3 X`, will keep just the samples for whom the Groupin_var3 is equal to "X". Multiple values for the same variable can be defined separated by commas (without spaces) (i.e. `-g Grouping_var3 X,Z`).

#### Mass filter (-m/--mass_filter)

This option takes two arguments: lower and an upper m/z limits. Peaks with m/z (masses) outside of its limits will be filtered out and not considered in the analysis.

#### Normalization method (-n/--norm_method)

This option defines which normalization method will be used to normalize the intensities (*I*). It can take one of the following options for *i* samples and *j* peaks.
Normalization methods are based on the ones used by Kitson, et al. (2021) and Thompson, et al. (2021)

|Normalization method|Formula|
|---|---|
|`max`|<img src="https://render.githubusercontent.com/render/math?math=NormIntensity_{i,j} = \frac{I_{i,j}}{max(I)_{i}}">|
|`minmax`|<img src="https://render.githubusercontent.com/render/math?math=NormIntensity_{i,j} = \frac{I_{i,j} - min(I)_{i}}{max(I)_{i} - min(I)_{i}}">|
|`mean`|<img src="https://render.githubusercontent.com/render/math?math=NormIntensity_{i,j} = \frac{I_{i,j} - mean(I)_{i}}{max(I)_{i} - min(I)_{i}}">|
|`median`|<img src="https://render.githubusercontent.com/render/math?math=NormIntensity_{i,j} = \frac{I_{i,j} - median(I)_{i}}{max(I)_{i} - min(I)_{i}}">|
|`sum`|<img src="https://render.githubusercontent.com/render/math?math=NormIntensity_{i,j} = \frac{I_{i,j}}{\sumI_{i}}">|
|`zscore`|<img src="https://render.githubusercontent.com/render/math?math=NormIntensity_{i,j} = \frac{I_{i,j} - mean(I)_{i}}{std.dev(I)_{i}}">|
|`binary`|Transform data into presence (1) absence (0)|
|`none`|Do not perform any normalization|

#### Normalization subset method (--norm_subset) and subset parameter (--subset_parameter)

If a normalization method other than `binary` or `none` is selected it is possible to use only a fraction of the peaks to calculate the normalization factors (normalization will still be applied to all the dataset). Possible subset methods are :

|Subset method|Description|
|---|---|
|`ALL`|Use all present peaks to calculate normalization factors|
|`LOS`|Use a percentage of peaks in the top L order statistics|
|`PPP`|Uses peaks that are present in more than minimum percentage of samples|

The option `--subset_parameter` defines the percentage of peaks that will be used in `LOS` or the minimum percentage of samples that a peak must be present for `PPP`.

#### KEGG annotation (-k/--kegg_annotation)

This is an optional step as it may take a long time (~ couple of hours) depending on the number of peaks present in the data. If this option is present, the assigned molecular formulas will be searched against the KEGG database to produce a table with their KEGG name, KEGG pathway, etc.

#### Transformation networks (-t/--transformation_analysis)

This option define whether or not a transformation network of the samples based on mass differences will be carried out. This step requires CYtoscape (version 3.8 and above) to be installed in the machine. **MetaboDirect** will ask the user to open Cytoscape when required in order to construct the networks. When prompted in the screen, please open Cytoscape and then hit enter to continue wiht the analysis.

#### Biochemical transformation key (-b/--biochem_key)

**MetaboDirect** comes with a biochemical transformation key that defines many of the most common transformations that happen in soil samples. This option can be used to enter a new biochemical key with transformations more closely related to the user's data. The default transformation key can be found in `/path/to/MetaboDirect/metabodirect/data/transf_key.csv`.

## MetaboDirect pipeline

The **MetaboDirect** pipeline includes 5 major steps: data pre-processing, data diagnostics, data exploration, statistical analysis, and transformation network analysis. In addition an optional script `normalization_test.py` can be run before **MetaboDirect** to help the user choose the best normalization method for the data.

### (Optional Step) Test normalization methods

A companion script called `normalization_test.py` is included to help in the decision of which normalization method to use. This script uses a procedure the Statistical Procedure for the Analysis of Normalization Strategies (SPANS) (Webb‐Robertson et al., 2011), which has been previously demonstrated to work well with FT-ICR MS data (Thompson et al., 2021).
Information about the arguments can be obtained using the -h/--help function.

```
test_normalization -h
```
This python script will generate an R script that utilizes a modified `spans_procedure()` function from the `pmartR` package (Stratton et al., 2019; Thompson et al., 2021). 
This script will produce a heatmap as a result with the "SPANS score" of the combination of each of the available normalization methods and data subset methods and subset parameters.

<p align="center"><img src="scores.png" width=450 alt="SPANS scores"></p>

### 1. Data pre-processing

<p align="center"><img src="pre_processing.png" width=1200 alt="Data pre-processing"></p>

During this step this step samples will samples will be filtered out based on the `-f` option. Detected peaks will also be filtered out inf the `-m` option was specificied. After filtering elemental ratios will be calculated. Compound classes will be defined based on elemental ratios, the boundaries to determine compound classes can be found (or modified) in the file `/path/to/MetaboDirect/metabodirect/data/compound_class_table.csv`. Thermodynamic indices are calculated based on the assigned molecular formula as follows:

|Index|Formula|
|---|---|
|Nominal Oxidation State of Carbon (NOSC)|<img src="https://render.githubusercontent.com/render/math?math=NOSC = \frac{4C + H -3N -2O +5P -2S}{C}%2B4">|
|Gibbs Free Energy (GFE)|<img src="https://render.githubusercontent.com/render/math?math=GFE=60.3-28.5 * NOSC">|
|Double Bond Equivalent (DBE)|<img src="https://render.githubusercontent.com/render/math?math=DBE = 1 %2B 0.5(2C-H %2B N %2B P)">|
|Aromatic Index (AI)|<img src="https://render.githubusercontent.com/render/math?math=AI = 1 %2B C - O - S - \frac{0.5(H %2B P %2B N)}{C - O - S - N - P}">|

Data will be normalized during this step to be used in all of the subsequent analysis.

### 2. Data diagnostics

<p align="center"><img src="diagnostics.png" width=325 alt="Data diagnostics"></p>

In this step the number of molecular formulas that were assigned per each sample will be plotted. In addition the error (in ppm) during the formula assigment will also be plotted based on the grouping variables.

### 3. Data exploration

<p align="center"><img src="exploration.png" width=400 alt="Data exploration"></p>

This step will generate and run an R script named `data_exploration.R`. This part of the analysis will generate plots for the elemental and compound class composition, Van Krevelen diagrams of the detected masses, violin and density plots of the previoulsy mentioned thermodynamic indices as well as plot of the diversity indices. In addition, it will generate directories that contain plots of the pairwise comparisons among the different values in the specified grouping variables.

If the option `-k` was selected another R script named `KEGG_annotation.R` will also be run and generated. It will produce an additional .csv file with the KEGG annotation.

### 4. Statistical Analysis

<p align="center"><img src="statistics.png" width=325 alt="Statistical Analysis"></p>

This step will generate and run an R script named `data_statistics.R`. During this step a Permutational multivariate analysis of variance (PERMANOVA) test will be applied to the dataset. Plots with the ordination of the samples using Non-metric Multidimensional Scaling (NMDS) and Principal Component Analysis (PCA) will be also generated.

### 5. Transformation Networks

<p align="center"><img src="transformations.png" width=700 alt="Transformation Networks"></p>

This step is optional since it is time consuming and it requires that Cytoscape is installed on your computer. During this step, the differences in the molecular weight of each of the peaks that were assigned a molecular formula will be calculated. Biochemical transformation will be determined and assigned based on the provided *biochemical transformation key*. The transformation key provided by default has biochemical transformations that are commonly observed on soil samples, this file can be found in the `/path/to/MetaboDirect/data/` directory with the name `transf_key.csv`. A different biochemical transformation key can be provided when running MetaboDirect using the `-b` option. Once transformation are calculated, transformation networks will be generated using Cytoscape. This networks will have the nodes colored based on the compound classes determined during the *pre-processing* step and the edges wil be colored based on the type of biochemical transformation. Finally an R script named `network_stats.R` will be generated and run to plot network statistics.

## References

- Kanehisa, M., & Goto, S. (2000). KEGG: Kyoto Encyclopedia of Genes and Genomes. Nucleic Acids Research, 28(1), 27-30. https://doi.org/10.1093/nar/28.1.27 
- Kitson, E., Kew, W., Ding, W., & Bell, N. G. A. (2021). PyKrev: A Python Library for the Analysis of Complex Mixture FT-MS Data. Journal of the American Society for Mass Spectrometry, 32(5), 1263-1267. https://doi.org/10.1021/jasms.1c00064 
- Shannon, P., Markiel, A., Ozier, O., Baliga, N. S., Wang, J. T., Ramage, D., Amin, N., Schwikowski, B., & Ideker, T. (2003). Cytoscape: a software environment for integrated models of biomolecular interaction networks. Genome research, 13(11), 2498-2504. https://doi.org/10.1101/gr.1239303
- Stratton, K. G., Webb-Robertson, B.-J. M., McCue, L. A., Stanfill, B., Claborne, D., Godinez, I., Johansen, T., Thompson, A. M., Burnum-Johnson, K. E., Waters, K. M., & Bramer, L. M. (2019). pmartR: Quality Control and Statistics for Mass Spectrometry-Based Biological Data. Journal of Proteome Research, 18(3), 1418-1425. https://doi.org/10.1021/acs.jproteome.8b00760
- Thompson, A. M., Stratton, K. G., Bramer, L. M., Zavoshy, N. S., & McCue, L. A. (2021). Fourier transform ion cyclotron resonance mass spectrometry (FT-ICR-MS) peak intensity normalization for complex mixture analyses [https://doi.org/10.1002/rcm.9068]. Rapid Communications in Mass Spectrometry, 35(9), e9068. https://doi.org/https://doi.org/10.1002/rcm.9068
- Tolić, N., Liu, Y., Liyu, A., Shen, Y., Tfaily, M. M., Kujawinski, E. B., Longnecker, K., Kuo, L.-J., Robinson, E. W., Paša-Tolić, L., & Hess, N. J. (2017). Formularity: Software for Automated Formula Assignment of Natural and Other Organic Matter from Ultrahigh-Resolution Mass Spectra. Analytical Chemistry, 89(23), 12659-12665. https://doi.org/10.1021/acs.analchem.7b03318
- Webb‐Robertson, B. J. M., Matzke, M. M., Jacobs, J. M., Pounds, J. G., & Waters, K. M. (2011). A statistical selection strategy for normalization procedures in LC‐MS proteomics experiments through dataset‐dependent ranking of normalization scaling factors. Proteomics, 11(24), 4736-4741.
